#define dw .word
#define .DRW .word
#define db .byte
;
;   ALL PUBLICATIONS OF THE FORTH INTEREST GROUP
; ARE PUBLIC DOMAIN. THEY MAY BE FURTHER
; DISTRIBUTED BY THE INCLUSION OF THIS CREDIT NOTICE:
;
; This publication has been made available by the
;	Forth Interest Group
;	P.O.Box 1105
;	San Carlos, CA 94070
;	U.S.A.
;
;
; FIG-FORTH version for VG5000
;==========================================================
; SOURCES :
; 1 - http://www.forth-ev.de/wiki/doku.php/projects:fig-forth_installation_manual
;and
; 2- Version for TC/TR STD bus CPU card.
;   Software drivers for CPU and I/O CARD BY D.Jackson 5/88
;
; =========================================================
; Implementation by Dominique Contant (mars 2014)
; http://forum.system-cfg.com/viewtopic.php?f=25&t=2067
;
; TASM - 
; http://www.ticalc.org/archives/files/fileinfo/15/1504.html
;
; C:\TASM>tasm -80 -b Figvg5000.asm
;
;   release and version numbers
;
FIGREL .EQU     1 ; FIG RELEASE #
FIGREV .EQU     1 ; FIG REVISION #
USRVER .EQU     $64; USER VERSION # 
;
;   This version for TC/TR STD bus CPU card.
;   Software drivers for CPU and I/O CARD BY D.Jackson 5/88
;
;
; ASCII CHAR USED
;
ABL .EQU        $20   ; SPACE
ACR .EQU        $0D   ; carrage return
ADOT .EQU       $2E   ; Period
BELL .EQU       $07   ; (^G)
BSIN .EQU      $02    ; Input Backspace char = DEL or RUBOUT
BSOUT .EQU      $02   ; Output Backspace (^h)
DLE .EQU      $10     ; (^P) Data Link Esape... PRINTER toggle
LF .EQU      $0A      ; Line Feed
FF .EQU      $0C      ; Form Feed (^L)
;
;MEMORY ALLOCATION
;
EM .EQU         $7FFE  ; Top of memory +1
NSCR .EQU       0       ; # of 1020 Byte Screens
KBBUF .EQU      128     ; Data Bytes per disk buffer
US .EQU         $40   ; User Variables space
RTS .EQU        $A0   ; Return stack and Terminal buff space
;
CO .EQU          KBBUF+4                ;Disk Buffer + 2 Header + 2 Tail
NBUF .EQU        NSCR*$400/KBBUF       ;# of Buffers
BUF1 .EQU        EM-(CO*NBUF)     ;Address of 1st Disk Buffer
INITR0 .EQU      BUF1-US                ; (R0)
INITS0 .EQU      INITR0-RTS     ; (S0)

	.ORG $5200
        
        JR      STRTUP
        NOP
        NOP
emit_addr:      	dw $0000                ;  Adresse cran de EMIT
copie_R2:		db $00
copie_R3:		db $00 
ret_basic       	dw $0000
 
	.ORG $5280
        
STRTUP: 
 
        JP  CLD
               
 
	.ORG $5300  ; Reserve space for Interupt Vectors
ORIG:   NOP
        JP       CLD            ; Vector to Cold Start
        NOP
        JP       WRM            ; VECTOR TO WARM START
        .DB        FIGREL       ;FIG RELEASE#
        .DB        FIGREV       ;FIG REVISION #
        .DB        USRVER       ;USER VERSION #
        .DB        $0E         ;IMPLEMENTATION ATRIBUTES
       	.DRW       fin_vocab ; TOPMOST WORD IN FORTH VOCAB
        .DRW       BSIN    ;BACKSPACE CHAR
        .DRW       INITR0  ;INIT (UP)


;
; <<<<<<<<<<<< FOLLOWING USED BY COLD;
;  MUST BE IN SAME ORDER AS USER VARIABLES
;
        .DRW       INITS0  ;INIT (S0)
        .DRW       INITR0  ;INIT (R0)
        .DRW       INITS0  ;INIT (TIB)
        .DRW       $1F         ; INIT (WIDTH)
        .DRW       0            ; INIT (WARNING)
                                ; 0=NO SCREEN 4 AVAIL AT STARTUP
                                ; 1= FORTH SCREENS ARE AVAIL
        .DRW       INITDP       ;INIT (FENCE)
        .DRW       INITDP       ;INIT (DP)
        .DRW       FORTH+8      ;INIT (VOC-LINK)
;
;  <<<<<<<<<<<< END DATA USED BY COLD
;

        .DRW       0,$B250    ;Z80 CPU NAME (HW,LW)
;                               32 BIT, BASE 36 INT
;                               32 BIT, BASE 36 INTEGER
;
 

script_40col_init:
       	db 1Eh                                 	;  'Longueur Script'
	db  $28, $81, $29 
data_tgs40:
	db  $00, 
	db  $20, $82, $29 
data_mat40:
	db  $2E, 
	db  $20, $83, $29 
data_pat40:
	db  $77 
	db  $20, $84, $29 
data_dor40:
	db  $13, 
	db  $20, $87, $29 
data_ror40:
	db  $08
	db  $22 
data_r240:
	db  $01
	db  $23 
data_r340:
	db  $06
	db  $26 
data_r640:
	db  $08 
	db  $27 
data_r740:
	db  $00
	db  $28 
data_krf40:
	db  $00

 


lire_script:				; Adresse dans HL

	push	hl
	ld	de, $0016
	add	hl, de
	ld	a,(hl)
	ld	(copie_R2),a
	ld	de,$0002
	add	hl,de
	ld	a,(hl)
	ld	(copie_R3),a
	pop	hl
	PUSH	BC
	CALL	$02ef
	POP	BC
	RET
;------------------------------------------------------------
;
;       FORTH REGISTERS
;
;       FORTH   Z80     FORTH PRESERVATION RULES
;       -----   ---     ------------------------
;       IP      BC      SHOULD BE PRESERVED ACROSS FORTH WORDS
;       W       DE      SOMETIMES O/P FROM NEXT
;                       MAY BE ALTERED BEFORE JMPING TO NEXT
;                       INPUT ONLY WHEN DPUSH CALLED
;       SP      SP      SHOULD BE USED ONLY AS DATA STACK
;                       ACROSS FORTH WORDS
;                       MAY BE USED WITHIN FORTH WORDS IF
;                       RESTORED BEFORE NEXT
;               HL      NEVER O/P FROM NEXT INPUT ONLY WHEN 
;                       HPUSH CALLED
;
UP:       .DRW    INITR0 ;USER AREA POINTER
RPP:      .DRW    INITR0 ;RETURN STACK POINTER
;
;-----------------------------------------------------------
;
;               COMMENT CONVENTIONS
;
;       =       MEANS   "IS EQUAL TO"
;       <-      MEANS   ASSIGNMENT
;
;       NAME    =       ADDRESS OF NAME
;       (NAME)  =       CONTENTS AT NAME
;       ((NAME))=       INDIRECT CONTENTS
;
;       CFA     =       ADDRESS OF CODE FILED
;       LFA     =       ADDRESS OF LINK FILED
;       NFA     =       ADDR OF START OF NAME FIELD
;       PFA     =       ADDR OF START OF PARAMETER FIELD
;  
;       S1      =       ADDR OF 1ST WORD OF PARAMETER STACK
;       S2      =       ADDR OF 2ND WORD OF PARAMETER STACK
;       R1      =       ADDR OF 1ST WORD OF RETURN STACK
;       R2      =       ADDR OF 2ND WORD OF RETURN STACK
;       (ABOVE STACK POSITIONS VALID BEFORE AND AFTER EXECUTION 
;       OF ANY WORD, NOT DURING. )
;
;       LSB     =       LEAST SIGNIFICANT BIT
;       MSB     =       MOST SIGNIFICANT BIT
;       LB      =       LO BYTE
;       HB      =       HIGH BYTE
;       LW      =       LOW WORD
;       HW      =       HIGH WORD
;       ( MAY BE USED AS SUFFIX TO NAMES)
;
;
;---------------------------------------------------
; 
;       NEXT , THE FORTH ADDR INTERPRETER
;         ( POST INCREMENTING VERSION )
;
l45ba:	
 

DPUSH:  PUSH DE
HPUSH:  PUSH HL
NEXT:   LD      A,(BC)  ;(W) <- ((IP))
        INC     BC      ;(IP) <- (IP)+2
        LD      L,A
NEXT3:  LD      A,(BC)  ;LABEL ADDED BY DLW
        INC     BC
        LD      H,A     ;(HL) <- CFA
NEXT1:  LD      E,(HL)  ;(PC) <- ((W))
        INC     HL
        LD      D,(HL)
        EX      DE,HL
        JP      (HL)    ;NOTE : (DE) = CFA +1
;-------
EXECUTE:        ; MOVED HERE TO PUT WITHIN RANGE OF JR FROM RST
        POP     HL      ;(HL) <- (S1) = CFA
        JR      NEXT1

;
;        FORTH DICTIONARY
;
;        DICTIONARY FORMAT:
;
;       ADDRESS NAME            BYTE CONTENTS
;       ------- ----            -------------
;                                 ( MSB =1 P=PRECEDENCE BIT, S=SMUDGE BIT
;
;       NFA     NAME FIELD      1PS<LEN>   < NAME LENGTH
;                               0<1CHAR>   MSB=0, NAME'S 1ST CHAR
;                               0<2CHAR>   
;                               .....
;                               1<LCHAR>   MSB=1, NAME'S LAST CHAR
;       LFA     LINK FIELD      <LINKLB>   = PREVIOUS WORD'S NFA
;                               <LINKHB>
;LABEL: CFA     CODE FIELD      <CODELB>   = ADDR CPU CODE
;                               <CODEHB>   
;       PFA     PARAMETER FIELD <1PARM>    1ST PARAMETER BYTE
;                               <2PARM>
;                               ......
;
DP0:    .DB     $83            ;LIT
        .DB     "LI",'T'+$80
        .DRW    0               ;(LFA)=0 MARKS END OF DICT
LIT:    .DRW    *+2             ;(S1) <- ((IP))
        LD      A,(BC)          ;(HL) <- ((IP)) = LITERAL
        INC     BC              ;(IP) <- (IP) +2
        LD      L,A             ;LB
        LD      A,(BC)          ;HB
        INC     BC
        LD      H,A
        JR      HPUSH           ;(S1) <- (HL)
;
        .DB     $87            ;EXECUTE
        .DB     "EXECUT",'E'+$80
        .DRW    LIT-6
EXEC:   .DRW    EXECUTE         ;MOVED BY DLW
;       .DRW    *+2
;       POP     HL 
;       JR      NEXT1
;
        .DB     $86            ; BRANCH
        .DB     "BRANC",'H'+$80
        .DRW    EXEC-$0A
BRAN:   .DRW    *+2             ;(IP) <- (IP) + ((IP))
BRAN1:  LD      H,B             ;(HL) <- (IP)
        LD      L,C
        LD      E,(HL)          ;(DE) <- ((IP)) = BRANCH OFFSET
        INC     HL
        LD      D,(HL)
        DEC     HL
        ADD     HL,DE           ;(HL) <- (HL) +((IP))
        LD      C,L             ;(IP) <- (HL)
        LD      B,H
        JR      NEXT
;
        .DB     $87            ;0BRANCH
        .DB     "0BRANC",'H'+$80
        .DRW    BRAN-9
ZBRAN:  .DRW    *+2
        POP     HL
        LD      A,L
        OR      H
        JR      Z,BRAN1         ;IF (S1)=0 THEN BRANCH
        INC     BC              ;ELSE SKIP BRANCH OFFSET
        INC     BC
        JR      NEXT
;
        .DB     $86            ;(LOOP)
        .DB     "(LOOP",')'+$80
        .DRW    ZBRAN-$0A
XLOOP:  .DRW    *+2
        LD      DE,1            ;(DE) <- INCREMENT
XLOO1:  LD      HL,(RPP)        ;((HL)) = INDEX
        LD      A,(HL)
        ADD     A,E
        LD      (HL),A
        LD      E,A
        INC     HL
        LD      A,(HL)
        ADC     A,D
        LD      (HL),A
        INC     HL              ;((HL)) = LIMIT
        INC     D
        DEC     D
        LD      D,A             ;(DE) <- NEW INDEX
        JP      M,XLOO2         ; IF INCR >0
        LD      A,E
        SUB     (HL)            ;THEN (A) <- INDEX - LIMIT
        LD      A,D
        INC     HL
        SBC     A,(HL)
        JR      XLOO3
XLOO2:  LD      A,(HL)          ;ELSE (A) <- LIMIT-INDEX
        SUB     E
        INC     HL
        LD      A,(HL)
        SBC     A,D
;
XLOO3:  JP      M,BRAN1         ;IF (A) < 0 THEN LOOP AGAIN
        INC     HL              ; ELSE DONE
        LD      (RPP),HL        ;DISCARD R1 &R2
        INC     BC              ;SKIP BRANCH OFFSET
        INC     BC
        JP      NEXT
;
        .DB     $87            ;(+LOOP)
        .DB     "(+LOOP",')'+$80
        .DRW    XLOOP-9
XPLOO:  .DRW    *+2
        POP     DE              ;(DE) <- INCR
        JR      XLOO1
;
        .DB     $84            ;(DO)
        .DB     "(DO",')'+$80
        .DRW    XPLOO-$0A
XDO:    .DRW    *+2
        LD      HL,(RPP)        ;(RP) <-(RP)-4
        DEC     HL
        DEC     HL
        DEC     HL
        DEC     HL
        LD      (RPP),HL
        POP     DE              ;(R1)<- (S1)=INIT INDEX
        LD      (HL),E
        INC     HL
        LD      (HL),D
        POP     DE              ;(R1)<-(S2) = LIMIT
        INC     HL
        LD      (HL),E
        INC     HL
        LD      (HL),D
        JP      NEXT
;
        .DB     $81            ;I
        .DB     'I'+$80
        .DRW    XDO-7
IDO:    .DRW    *+2             ;(S1)<-(R1),(R1) UNCHANGED
        LD      HL,(RPP)
        LD      E,(HL)          ;(DE) <-(R1)
        INC     HL
        LD      D,(HL)
        PUSH    DE              ;(S1) <- (DE)
        JP      NEXT
;
        .DB     $85            ;DIGIT
        .DB     "DIGI",'T'+$80
        .DRW    IDO-4
DIGIT:  .DRW    *+2
        POP     HL              ;(L) <- (S1)LB = ASCII CHAR TO 
;                               ;BE CONVERTED
        POP     DE              ;(DE) <- (S2) = BASE VALUE
        LD      A,E
        SUB     $30            ;IF CHAR > "0"
        JP      M,DIGI2
        CP      $0A            ;AND IF CHAR > "9"
        JP      M,DIGI1
        SUB     7
        CP      $0A            ;AND IF CHR > = "A"
        JP      M,DIGI2
;                               ;    THEN VALID NUMERIC OR ALPHA CHR
DIGI1:  CP      L               ;IF < BASE VALUE
        JP      P,DIGI2
;                               ; THEN VALID DIGIT CHR
        LD      E,A             ;(S2) <- (DE) = CONVERTED DIGIT
        LD      HL,1            ;(S1) <- TRUE
        JP      DPUSH
;                               ;ELSE INVALID DIGIT CHR
DIGI2:  LD      L,H             ;(HL) <- FALSE
        JP      HPUSH           ;(S1) <- FALSE
;
        .DB     $86            ;(FIND) (2-1)FAILURE
        .DB     "(FIND",')'+$80        ;       (2-3) SUCCESS
        .DRW    DIGIT-8
PFIND:  .DRW    *+2
        POP     DE              ;(DE) <- NFA
PFIN1:  POP     HL              ;(HL) <- STRING ADDR
        PUSH    HL              ;SAVE STRING ADDR FOR NEXT ITERATION
        LD      A,(DE)
        XOR     (HL)            ;CHECK LENGTHS AND SMUDGE BIT
        AND     $3F
        JR      NZ,PFIN4        ;LENGTHS DIFFERENT
;                               ;LENGTHS MATCH, CHECK EACH CHAR
PFIN2:  INC     HL              ;(HL) <- ADDR NEXT CHR IN STRING
        INC     DE              ;(DE) <- ADDR NEXT CHR IN NF
        LD      A,(DE)
        XOR     (HL)            ;IGNORE MSB
        ADD     A,A
        JR      NZ,PFIN3                  ;NO MATCH
        JR      NC,PFIN2                  ;MATCH SO FAR, LOOP AGAIN
        LD      HL,5            ;STRING MATCHES
        ADD     HL,DE           ;((SP)) <- PFA
        EX      (SP),HL
;                               ;BACK UP TO LENGTH OF BYTE OF NF=NFA
PFIN6:  DEC     DE
        LD      A,(DE)
        OR      A
        JP      P,PFIN6         ;IF MSB=1 THEN (DE)=NFA
        LD      E,A             ;(DE) <-LENGTH BYTE
        LD      D,0
        LD      HL,1            ;(HL) <-TRUE
        JP      DPUSH           ;RETURN, NF FOUND
;                               ; ABOVE NF NOT A MATCH, TRY ANOTHER
PFIN3:  JR      C,PFIN5         ;IF NOT END OF NF
PFIN4:  INC     DE              ;THEN FIND END OF NF
        LD      A,(DE)
        OR      A
        JP      P,PFIN4
PFIN5:  INC     DE              ;(DE) <- LFA
        EX      DE,HL
        LD      E,(HL)          ;(DE) <- (LFA)
        INC     HL
        LD      D,(HL)
        LD      A,D
        OR      E               ;IF (LFA) <> 0
        JR      NZ,PFIN1        ;THEN TRY PREVIOUS DICT DEF.
;                               ; ELSE END OF DICTIONARY
        POP     HL              ;DISCARD STRING ADDR
        LD      HL,0            ;(HL) <- FALSE
        JP      HPUSH           ;RETURN, NO MATCH FOUND
;
        .DB     $87    ;ENCLOSE
        .DB     "ENCLOS",'E'+$80
        .DRW    PFIND-9
ENCL:   .DRW    *+2
        POP     DE      ;(DE) <-(S1)= DELIMITER CHAR
        POP     HL      ;(HL)<- (S2) = ADDR TEXT TO SCAN
        PUSH    HL      ;(S4) <- ADDR
        LD      A,E
        LD      D,A     ;(D) <- DELIM CHAR
        LD      E,-1    ;IIT CHR OFFSET COUNTER
        DEC     HL      ;(HL) <-ADDR-1
        ;            SKIP OVER LEADING DELIMITER CHRS
ENCL1:  INC    HL
        INC    E
        CP     (HL)    ;IF TEXT CHR = DELIM CHR
        JR     Z,ENCL1 ;THEN LOOP AGAIN
        ;                ELSE NON-DELIM CHR FOUND
        LD     D,0      ;(D3)<- (E) = OFFSET TO 1ST NON DELIM
        PUSH    DE
        LD      D,A     ;(D) <- DELIM CHR
        LD      A,(HL)  ;IF 1ST NON-DELIM = NULL
        AND     A
        JR      NZ,ENCL2        ;
        LD      D,0     ;THEN (S2)<-OFFSET TO BYTE
        INC     E
        PUSH    DE
        DEC     E
        PUSH    DE
        JP      NEXT
                        ;       ELSE TEXT CONTAINS NON-DELIM 
                        ;       & NON-NULL CHAR
ENCL2:  LD      A,D     ;(A) <- DELIM CHR
        INC     HL      ;(HL) <- ADDR NEXT CHR
        INC     E       ;(E) <- OFFSET TO NEXT CHR
        CP      (HL)    ;IF NEXT CHR <> DELIM CHR
        JR      Z,ENCL4
        LD      A,(HL)  ;AND IF NEXT CHR <> NULL
        AND     A
        JR      NZ,ENCL2        ;THEN CONINUE SCAN
        ;                        ELSE CHR=NULL
ENCL3:  LD      D,0     ;(S2)<- OFFSET TO NULL
        PUSH    DE
        PUSH    DE      ;(S1)<-OFFSET TO NULL
        JP      NEXT
        ;               ELSE CHR=DELIM CHR
ENCL4:  LD      D,0     ;(D2) <-OFFSET TO BYTE
;                               FOLLWOING TEXT
        PUSH    DE
        INC     E       ;(S1) <-OFFSET TO 2 BYTES AFTER
        ;                   END OF WORD
        PUSH    DE
        JP      NEXT
        ;
        .DB     $84    ;EMIT
        .DB     "EMI",'T'+$80
        .DRW    ENCL-$0A
EMIT:   .DRW    DOCOL
        .DRW    PEMIT
        .DRW    ONE,OUTT
        .DRW    PSTOR,SEMIS
        ;
        .DB     $83    ;KEY
        .DB     "KE",'Y'+$80
        .DRW    EMIT-7
KEY:    .DRW    *+2
        JP      PKEY
        ;
        .DB     $89    ;?TERMINAL
        .DB     "?TERMINA",'L'+$80
        .DRW    KEY-6
QTERM:  .DRW    *+2
        LD      HL,0
        JP      PQTER
        ;
        .DB     $82    ;CR
        .DB     "C",'R'+$80
        .DRW    QTERM-$0C
CR:     .DRW    *+2
        JP      PCR
        ;
        .DB     $85    ;CMOVE
        .DB     "CMOV",'E'+$80
        .DRW    CR-5
CMOVE:  .DRW    *+2
        LD      L,C     ;(HL)<- (IP)
        LD      H,B
        POP     BC      ;(BC) <-(S1)=#CHRS
        POP     DE      ;(DE)<- (S2)=DEST ADDR
        EX      (SP),HL ;(HL)<-(S3)= SOURCE ADDR
        ;                       (S1)<-(IP)
        JR      CMOV2   ;RETURN IF #CHRS=0
CMOV1:  LD      A,(HL)  ;((DE)) <- ((HL))
        INC     HL      ;INC SOURCE ADDR
        LD      (DE),A
        INC     DE      ;INC DEST ADDR
        DEC     BC      ;DEC #CHRS
CMOV2:  LD      A,B
        OR      C
        JR      NZ,CMOV1        ;REPEAT IF #CHR <>0
        POP     BC      ;RESTORE (IP) FROM (S1)
        JP      NEXT
        ;
        .DB     $82    ;U*  16X16 UNSIGNED MULTIPLY
        .DB     "U",'*'+$80    ;AVERAGE EXECUTION TIME = 994 CYCLES (8080)
        .DRW    CMOVE-8
USTAR:  .DRW    *+2
        POP     DE      ;(DE)<- MPLIER
        POP     HL      ;(HL)<- MPCAND
        PUSH    BC      ;SAVE IP
        LD      B,H
        LD      A,L     ;(BA)<- ,MPCAND
        CALL    MPYX    ;(AHL)1<- MPCAND.LB*MPLIER  1ST PARTIAL PROD
        PUSH    HL      ;SAVE (HL)1
        LD      H,A
        LD      A,B
        LD      B,H     ;SAVE (A)1
        CALL    MPYX    ;(AHL)2<-MPCAND.HB*MPLIER 2ND PARTIAL PROD
        POP     DE      ;(DE)<- (HL)1
        LD      C,D     ;(BC)<- (AH)1
        ;FORM SUM OF PARTIALS: (AHL)1
        ;                     +(AHL)2
        ;                       _____
        ;                     (AHLE)
        ADD     HL,BC   ;(HL)<-(HL)2 + (AH)1
        ADC     A,0     ;(AHLE) <-(BA) *(DE)
        LD      D,L
        LD      L,H
        LD      H,A     ;(HLDE)<- MPLIER*MPCAND
        POP     BC      ;RESTORE IP
        PUSH    DE      ;(S2)<- PRODUCT.LW
        JP      HPUSH   ;(S1)<- PRODUCT.HW
        ;
        ;MULTIPLY PRIMITIVE
        ;    (AHL)<- (A)*(DE)
        ;#BITS 24    8    16
MPYX:   LD      HL,0    ;(HL)<-0 PARTICAL PROD.LW
        LD      C,8     ;LOOP COUNTER
MPYX1:  ADD     HL,HL   ;LEFT SHIFT (AHL) 24 BITS
        RLA
        JR      NC,MPYX2        ;IF NEXT MPLIER BIT =1
        ADD     HL,DE   ;THEN ADD MPCAND
        ADC     A,0
MPYX2:  DEC     C       ;IFNOT LAST MPLIER BIT
        JR      NZ,MPYX1        ;THEN LOOP AGAIN
        RET                     ;ELSE DONE
        ;
        .DB     $82    ;U/
        .DB     "U",'/'+$80
        .DRW    USTAR-5
USLAS:  .DRW    *+2
        LD      HL,4
        ADD     HL,SP   ;((HL))<-NUMERATOR.LW
        LD      E,(HL)  ;(DE)<- NUMER.LW
        LD      (HL),C  ;SAVE IP ON STACK
        INC     HL
        LD      D,(HL)
        LD      (HL),B
        POP     BC      ;(BC)<- DENOMINATOR
        POP     HL      ;(HL)<-NUMER.HW
        LD      A,L
        SUB     C       ;IF NUMER >=DEMON
        LD      A,H
        SBC     A,B
        JR      C,USLA1 ;
        LD      HL,$0FFFF      ;THEN OVERFLOW
        LD      DE,$0FFFF      ;SET REM AND QUOT TO MAX
        JR      USLA7
USLA1:  LD      A,16    ;LOOP COUNTER
USLA2:  ADD     HL,HL   ;LEFT SHIFT (HLDE) THRU CARRY
        RLA
        EX      DE,HL
        ADD     HL,HL
        JR      NC,USLA3
        INC     DE
        AND     A
USLA3:  EX      DE,HL   ;SHIFT DONE
        RRA     ;RESTORE 1ST CARRY
        PUSH    AF      ;SAVE COUNTER
        JR      NC,USLA4        ;IF CARRY=1
        LD      A,L     ;THEN (HL)<-(HL)-(BC)
        SUB     C
        LD      L,A
        LD      A,H
        SBC     A,B
        LD      H,A
        JR      USLA5
USLA4:  LD      A,L     ;ELSE TRY (HL)<-(HL)-(BC)
        SUB     C
        LD      L,A
        LD      A,H
        SBC     A,B     ;(HL)<- PARTIAL REMAINDER
        LD      H,A
        JR      NC,USLA5
        ADD     HL,BC   ;JUNDERFLOW,RESTORE
        DEC     DE
USLA5:  INC     DE      ;INC QUOT
USLA6:  POP     AF      ;RESTORE COUNTER
        DEC     A       ;IF COUNTER > 0
        JR      NZ,USLA2        ;THEN LOOP AGAIN
USLA7:  POP     BC      ;ELSE DONE, RESOTRE IP
        PUSH    HL      ;(S2)<- REMAINDER
        PUSH    DE      ;(S1) <- QUOTIENT
        JP      NEXT
        ;
        .DB     $83    ;AND
        .DB     "AN",'D'+$80
        .DRW    USLAS-5
ANDD:   .DRW    *+2     ;(S1) <- (S1) AND (S2)
        POP     DE
        POP     HL
        LD      A,E
        AND     L
        LD      L,A
        LD      A,D
        AND     H
        LD      H,A
        JP      HPUSH
        ;
        .DB     $82    ;OR
        .DB     "O",'R'+$80
        .DRW    ANDD-6
ORR:    .DRW    *+2     ;(S1) <- (S1) OR (S2)
        POP     DE
        POP     HL
        LD      A,E
        OR      L
        LD      L,A
        LD      A,D
        OR      H
        LD      H,A
        JP      HPUSH
        ;
        .DB     $83    ;XOR
        .DB     "XO",'R'+$80
        .DRW    ORR-5
XORR:   .DRW    *+2     ;(S1) <- (S1) XOR (S2)
        POP     DE
        POP     HL
        LD      A,E
        XOR     L
        LD      L,A
        LD      A,D
        XOR     H
        LD      H,A
        JP      HPUSH
        ;
        .DB     $83    ;SP@
        .DB     "SP",'@'+$80
        .DRW    XORR-6
SPAT:   .DRW    *+2     ;(S1) <- (SP)
        LD      HL,0
        ADD     HL,SP   ;(HL) <- (SP)
        JP      HPUSH   ;(S1) <- (HL)
        ;
        .DB     $83    ;STACK POINTER STORE
        .DB "SP",'!'+$80
        .DRW    SPAT-6
SPSTO:  .DRW    *+2     ;(SP) <- (S0) USER VARIABLE
        LD      HL,(UP) ;(HL) <- USER VAR BASE ADDR
        LD      DE,6
        ADD     HL,DE   ;(HL) <- S0
        LD      E,(HL)  ;(DE) <- (S0)
        INC     HL
        LD      D,(HL)
        EX      DE,HL
        LD      SP,HL   ;(SP) <- (S0)
        JP      NEXT
        ;
        .DB     $83    ; RP@
        .DB     "RP",'@'+$80
        .DRW    SPSTO-6
RPAT:   .DRW    *+2     ;(S1) <- (RP)
        LD      HL,(RPP)
        JP      HPUSH
        ;
        .DB     $83    ;RETURN STACK POINTER STORE
        .DB     "RP",'!'+$80
        .DRW    RPAT-6
RPSTO:  .DRW    *+2     ;(RP) <- (R0) USER VARIABLE
        LD      HL,(UP) ;(HL) <- USER VARIABLE BASE ADDR
        LD      DE,8
        ADD     HL,DE   ;(HL) <- R0
        LD      E,(HL)  ;(DE) <- (R0)
        INC     HL
        LD      D,(HL)
        EX      DE,HL
        LD      (RPP),HL        ;(RP) <- (R0)
        JP      NEXT
        ;
        .DB     $82    ;;S
        .DB     ";",'S'+$80
        .DRW    RPSTO-6
SEMIS:  .DRW    *+2     ;(IP) <- (R1)
        LD      HL,(RPP)
        LD      C,(HL)  ;(BC) <- (R1)
        INC     HL
        LD      B,(HL)
        INC     HL
        LD      (RPP),HL        ;(RP) <- (RP)+2
        JP      NEXT
        ;
        .DB     $85    ;LEAVE
        .DB     "LEAV",'E'+$80
        .DRW    SEMIS-5
LEAVE:  .DRW    *+2     ;LIMIT <- INDEX
        LD      HL,(RPP)
        LD      E,(HL)  ;(DE) <- (R1)= INDEX
        INC     HL
        LD      D,(HL)
        INC     HL
        LD      (HL),E  ;(R2) <- (DE) = LIMIT
        INC     HL
        LD      (HL),D
        JP      NEXT
        ;
        .DB     $82    ; >R
        .DB     ">",'R'+$80
        .DRW    LEAVE-8
TOR:    .DRW    *+2
        POP     DE
        LD      HL,(RPP)
        DEC     HL
        DEC     HL
        LD      (RPP),HL
        LD      (HL),E
        INC     HL
        LD      (HL),D
        JP      NEXT
        ;
        .DB     $82    ; R>
        .DB     "R",'>'+$80
        .DRW    TOR-5
FROMR:  .DRW    *+2
        LD      HL,(RPP)
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        INC     HL
        LD      (RPP),HL
        PUSH    DE
        JP      NEXT
        ;
        .DB     $81    ; R
        .DB     'R'+$80
        .DRW    FROMR-5
FRR:    .DRW     IDO+2
        ;
        .DB     $82    ;0=
        .DB     "0",'='+$80
        .DRW    FRR-4
ZEQU:   .DRW    *+2
        POP     HL
        LD      A,L
        OR      H
        LD      HL,0
        JR      NZ,ZEQU1
        INC     HL
ZEQU1:  JP      HPUSH
;
        .DB     $82    ; 0<
        .DB     "0",'<'+$80
        .DRW    ZEQU-5
ZLESS:  .DRW    *+2
        POP     HL
        ADD     HL,HL
        LD      HL,0
        JR      NC,ZLES1
        INC     HL
ZLES1:  JP      HPUSH
        ;
        .DB     $81    ; +
        .DB '+'+$80
        .DRW    ZLESS-5
PLUS:   .DRW    *+2
        POP     DE
        POP     HL
        ADD     HL,DE
        JP      HPUSH
        ;
        .DB     $82    ; D+ (4-2)
        .DB     "D",'+'+$80
        .DRW    PLUS-4
DPLUS:  .DRW    *+2
        LD      HL,6
        ADD     HL,SP
        LD      E,(HL)
        LD      (HL),C
        INC     HL
        LD      D,(HL)
        LD      (HL),B
        POP     BC
        POP     HL
        ADD     HL,DE
        EX      DE,HL
        POP     HL
        LD      A,L
        ADC     A,C
        LD      L,A
        LD      A,H
        ADC     A,B
        LD      H,A
        POP     BC
        PUSH    DE
        JP      HPUSH
        ;
        .DB     $85    ; MINUS
        .DB     "MINU",'S'+$80
        .DRW    DPLUS-5
MINUS:  .DRW    *+2
        POP     HL
        LD      A,L
        CPL
        LD      L,A
        LD      A,H
        CPL
        LD      H,A
        INC     HL
        JP      HPUSH
        ;
        .DB     $86    ; DMINUS
        .DB     "DMINU",'S'+$80
        .DRW    MINUS-8
DMINU:  .DRW    *+2
        POP     HL
        POP     DE
        SUB     A
        SUB     E
        LD      E,A
        LD      A,0
        SBC     A,D
        LD      D,A
        LD      A,0
        SBC     A,L
        LD      L,A
        LD      A,0
        SBC     A,H
        LD      H,A
        PUSH    DE
        JP      HPUSH
        ;
        .DB     $84    ; OVER
        .DB     "OVE",'R'+$80
        .DRW    DMINU-9
OVER:   .DRW    *+2
        POP     DE
        POP     HL
        PUSH    HL
        JP      DPUSH
        ;
        .DB     $84    ;DROP
        .DB     "DRO",'P'+$80
        .DRW    OVER-7
DROP:   .DRW    *+2
        POP     HL
        JP      NEXT
        ;
        .DB     $84    ;SWAP
        .DB     "SWA",'P'+$80
        .DRW    DROP-7
SWAP:   .DRW    *+2     
        POP     HL
        EX      (SP),HL
        JP      HPUSH
        ;
        .DB     $83    ; DUP
        .DB     "DU",'P'+$80
        .DRW    SWAP-7
DUP:    .DRW    *+2
        POP     HL
        PUSH    HL
        JP      HPUSH
        ;
        .DB     $84    ; 2DUP
        .DB "2DU",'P'+$80
        .DRW    DUP-6
TDUP:   .DRW    *+2
        POP     HL
        POP     DE
        PUSH    DE
        PUSH    HL
        JP      DPUSH
        ;
        .DB     $82    ; PLUS STORE
        .DB     "+",'!'+$80
        .DRW    TDUP-7
PSTOR:  .DRW    *+2
        POP     HL
        POP     DE
        LD      A,(HL)
        ADD     A,E
        LD      (HL),A
        INC     HL
        LD      A,(HL)
        ADC     A,D
        LD      (HL),A
        JP      NEXT
        ;
        .DB     $86    ;TOGGLE
        .DB     "TOGGL",'E'+$80
        .DRW    PSTOR-5
TOGGL:  .DRW     *+2
        POP     DE
        POP     HL
        LD      A,(HL)
        XOR     E
        LD      (HL),A
        JP      NEXT
        ;
        .DB     $81    ;@
        .DB     '@'+$80
        .DRW    TOGGL-9
AT:     .DRW    *+2
        POP     HL
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        PUSH    DE
        JP      NEXT
        ;
        .DB     $82    ;C@
        .DB     "C",'@'+$80
        .DRW    AT-4
CAT:    .DRW    *+2
        POP     HL
        LD      L,(HL)
        LD      H,0
        JP      HPUSH
        ;
        .DB     $82    ;2@
        .DB     "2",'@'+$80
        .DRW    CAT-5
TAT:    .DRW    *+2
        POP     HL
        LD      DE,2
        ADD     HL,DE
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        PUSH    DE
        LD      DE,-3
        ADD     HL,DE
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        PUSH    DE
        JP      NEXT
        ;
        .DB     $81    ;STORE
        .DB     '!'+$80
        .DRW    TAT-5
STORE:  .DRW    *+2
        POP     HL
        POP     DE
        LD      (HL),E
        INC     HL
        LD      (HL),D
        JP      NEXT
        ;
        .DB     $82    ;C STORE
        .DB     "C",'!'+$80
        .DRW    STORE-4
CSTOR:  .DRW    *+2
        POP     HL
        POP     DE
        LD      (HL),E
        JP      NEXT
        ;
        .DB     $82    ;2STORE
        .DB     "2",'!'+$80
        .DRW    CSTOR-5
TSTOR:  .DRW    *+2
        POP     HL
        POP     DE
        LD      (HL),E
        INC     HL
        LD      (HL),D
        INC     HL
        POP     DE
        LD      (HL),E
        INC     HL
        LD      (HL),D
        JP      NEXT
        ;
        .DB     $0C1   ; : (COLON)
        .DB     ':'+$80
        .DRW    TSTOR-5
COLON:  .DRW    DOCOL
        .DRW    QEXEC
        .DRW    SCSP
        .DRW    CURR
        .DRW    AT
        .DRW    CONT
        .DRW    STORE
        .DRW    CREAT
        .DRW    RBRAC
        .DRW    PSCOD
DOCOL:  LD      HL,(RPP)
        DEC     HL
        LD      (HL),B
        DEC     HL
        LD      (HL),C
        LD      (RPP),HL
        INC     DE
        LD      C,E
        LD      B,D
        JP      NEXT
        ;
        .DB     $0C1   ; ; (SEMICOLON)
        .DB     ';'+$80
        .DRW    COLON-4
SEMI:   .DRW    DOCOL
        .DRW    QCSP
        .DRW    COMP
        .DRW    SEMIS
        .DRW    SMUDG
        .DRW    LBRAC
        .DRW    SEMIS
        ;
        .DB     $84    ; NOOP
        .DB     "NOO",'P'+$80
        .DRW    SEMI-4
NOOP:   .DRW    DOCOL
        .DRW    SEMIS
        ;
        .DB     $88    ; CONSTANT
        .DB     "CONSTAN",'T'+$80
        .DRW    NOOP-7
CON:    .DRW    DOCOL
        .DRW    CREAT
        .DRW    SMUDG
        .DRW    COMMA
        .DRW    PSCOD
DOCON:  INC     DE
        EX      DE,HL
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        PUSH    DE
        JP      NEXT 
        ;
        .DB     $88    ; VARIABLE
        .DB     "VARIABL",'E'+$80
        .DRW    CON-$0B
VAR:    .DRW    DOCOL
        .DRW    CON
        .DRW    PSCOD
DOVAR:  INC     DE
        PUSH    DE
        JP      NEXT
        ;
        .DB     $84    ; USER
        .DB     "USE",'R'+$80
        .DRW    VAR-$0B
USER:   .DRW    DOCOL
        .DRW    CON
        .DRW    PSCOD
DOUSE:  INC     DE
        EX      DE,HL
        LD      E,(HL)
        LD      D,0
        LD      HL,(UP)
        ADD     HL,DE
        JP      HPUSH
        ;
        .DB     $81    ; 0
        .DB     '0'+$80
        .DRW    USER-7
ZERO:   .DRW    DOCON
        .DRW    0
        ;
        .DB     $81    ;1
        .DB     '1'+$80
        .DRW    ZERO-4
ONE:    .DRW    DOCON
        .DRW    1
        ;
        .DB     $81    ;2
        .DB     '2'+$80
        .DRW    ONE-4
TWO:    .DRW    DOCON
        .DRW    2
        ;
        .DB     $81    ;3
        .DB     '3'+$80
        .DRW    TWO-4
THREE:  .DRW    DOCON
        .DRW    3
        ;
        .DB     $82    ; BL
        .DB     "B",'L'+$80
        .DRW    THREE-4
BL:     .DRW    DOCON
        .DRW    $20
        ;
        .DB     $83    ;C/L CHARS/LINE
        .DB     "C/",'L'+$80
        .DRW    BL-5
CSLL:   .DRW    DOCON
        .DRW    64
        ;
        .DB     $85    ;FIRST
        .DB     "FIRS",'T'+$80
        .DRW    CSLL-6
FIRST:  .DRW    DOCON
        .DRW    BUF1
        ;
        .DB     $85    ; LIMIT
        .DB     "LIMI",'T'+$80
        .DRW    FIRST-8
LIMIT:  .DRW    DOCON
        .DRW    EM
        ;
        .DB     $85    ; B/BUF (BYTES/BUFFER)
        .DB     "B/BU",'F'+$80
        .DRW    LIMIT-8
BBUF:   .DRW    DOCON
        .DRW    KBBUF
        ;
        .DB     $85    ; B/SCR (BUFFERS/SCREEN)
        .DB     "B/SC",'R'+$80
        .DRW    BBUF-8
BSCR:   .DRW    DOCON
        .DRW    $400/KBBUF
        ;
        .DB     $87    ; +ORGIN
        .DB     "+ORIGI",'N'+$80
        .DRW    BSCR-8
PORIG:  .DRW    DOCOL
        .DRW    LIT
        .DRW    ORIG
        .DRW    PLUS
        .DRW    SEMIS
        ;
        ;    USER VARIABLES
        ;
        .DB     $82    ; S0
        .DB     "S",'0'+$80
        .DRW    PORIG-$0A
SZERO:  .DRW    DOUSE
        .DRW    6
        ;
        .DB     $82    ;R0
        .DB     "R",'0'+$80
        .DRW    SZERO-5
RZERO:  .DRW    DOUSE
        .DRW    8
        ;
        .DB     $83    ;TIB
        .DB     "TI",'B'+$80
        .DRW    RZERO-5
TIB:    .DRW    DOUSE
        .DB     $0A
        ;
        .DB     $85    ;WIDTH
        .DB     "WIDT",'H'+$80
        .DRW    TIB-6
WIDTH:  .DRW    DOUSE
        .DB     $0C
        ;
        .DB     $87    ;WARNING
        .DB     "WARNIN",'G'+$80
        .DRW    WIDTH-8
WARN:   .DRW    DOUSE
        .DB     $0E
        ;
        .DB     $85    ;FENCE
        .DB     "FENC",'E'+$80
        .DRW    WARN-$0A
FENCE:  .DRW    DOUSE
        .DB     $10
        ;
        .DB     $82    ;DP
        .DB     "D",'P'+$80
        .DRW    FENCE-8
DP:     .DRW    DOUSE
        .DB     $12
        ;
        .DB     $88    ;VOC-LINK
        .DB     "VOC-LIN",'K'+$80
        .DRW    DP-5
VOCL:   .DRW    DOUSE
        .DRW    $14
        ;
        .DB     $83    ;BLK
        .DB     "BL",'K'+$80
        .DRW    VOCL-$0B
BLK:    .DRW    DOUSE
        .DB     $16
        ;
        .DB     $82    ;IN
        .DB     "I",'N'+$80
        .DRW    BLK-6
INN:    .DRW    DOUSE
        .DB     $18
        ;
        .DB     $83    ;OUT
        .DB     "OU",'T'+$80
        .DRW    INN-5
OUTT:   .DRW    DOUSE
        .DB     $1A
        ;
        .DB     $83    ;SCR
        .DB     "SC",'R'+$80
        .DRW    OUTT-6
SCR:    .DRW    DOUSE
        .DB     $1C
        ;
        .DB     $86    ;OFFSET
        .DB     "OFFSE",'T'+$80
        .DRW    SCR-6
OFSET:  .DRW    DOUSE
        .DB     $1E
        ;
        .DB     $87    ;CONTEXT
        .DB     "CONTEX",'T'+$80
        .DRW    OFSET-9
CONT:   .DRW    DOUSE
        .DB     $20
        ;
        .DB     $87    ;CURRENT
        .DB     "CURREN",'T'+$80
        .DRW    CONT-$0A
CURR:   .DRW    DOUSE
        .DB     $22
        ;
        .DB     $85    ;STATE
        .DB     "STAT",'E'+$80
        .DRW    CURR-$0A
STATE:  .DRW    DOUSE
        .DB     $24
        ;
        .DB     $84    ; BASE
        .DB     "BAS",'E'+$80
        .DRW    STATE-8
BASE:   .DRW    DOUSE
        .DB     $26
        ;
        .DB     $83    ;DPL
        .DB     "DP",'L'+$80
        .DRW    BASE-7
DPL:    .DRW    DOUSE
        .DB     $28
        ;
        .DB     $83    ;FLD
        .DB     "FL",'D'+$80
        .DRW    DPL-6
FLD:    .DRW    DOUSE
        .DB     $2A
        ;
        .DB     $83    ;CSP
        .DB     "CS",'P'+$80
        .DRW    FLD-6
CSPP:   .DRW    DOUSE
        .DB     $2C
        ;
        .DB     $82    ; R#
        .DB     "R",'#'+$80
        .DRW    CSPP-6
RNUM:   .DRW    DOUSE
        .DB     $2E
        ;
        .DB     $83    ;HLD
        .DB     "HL",'D'+$80
        .DRW    RNUM-5
HLD:    .DRW    DOUSE
        .DRW    $30
        ;
        ;END OF USER VARIABLES
        ;
        .DB     $82    ;1+
        .DB     "1",'+'+$80
        .DRW    HLD-6
ONEP:   .DRW    DOCOL
        .DRW    ONE
        .DRW    PLUS
        .DRW    SEMIS
        ;
        .DB     $82    ; 2+
        .DB     "2",'+'+$80
        .DRW    ONEP-5
TWOP:   .DRW    DOCOL
        .DRW    TWO
        .DRW    PLUS
        .DRW    SEMIS
        ;
        .DB     $84    ;HERE
        .DB     "HER",'E'+$80
        .DRW    TWOP-5
HERE:   .DRW    DOCOL
        .DRW    DP
        .DRW    AT
        .DRW    SEMIS
        ;
        .DB     $85    ; ALLOT
        .DB     "ALLO",'T'+$80
        .DRW    HERE-7
ALLOT:  .DRW    DOCOL
        .DRW    DP
        .DRW    PSTOR
        .DRW    SEMIS
        ;
        .DB     $81    ;, (COMMA)
        .DB     ','+$80
        .DRW    ALLOT-8
COMMA:  .DRW    DOCOL
        .DRW    HERE
        .DRW    STORE
        .DRW    TWO
        .DRW    ALLOT
        .DRW    SEMIS
        ;
        .DB     $82    ;C,
        .DB     "C",','+$80
        .DRW    COMMA-4
CCOMM:  .DRW    DOCOL
        .DRW    HERE
        .DRW    CSTOR
        .DRW    ONE
        .DRW    ALLOT
        .DRW    SEMIS
        ;
        ;    SUBROUTINE USED BY - AND <
        ;
SSUB:   LD      A,L
        SUB     E
        LD      L,A
        LD      A,H
        SBC     A,D
        LD      H,A
        RET
        ;
        .DB     $81    ; - (MINUS SIGN)
        .DB     '-'+$80
        .DRW    CCOMM-5
SUBB:   .DRW    *+2
        POP     DE
        POP     HL
        CALL    SSUB
        JP      HPUSH
        ;
        .DB     $81    ; = EQUAL SIGN
        .DB     '='+$80
        .DRW    SUBB-4
EQUAL:  .DRW    DOCOL
        .DRW    SUBB
        .DRW    ZEQU
        .DRW    SEMIS
        ;
        .DB     $81    ; < LESS THAN
        .DB     '<'+$80
        .DRW    EQUAL-4
LESS:   .DRW    *+2
        POP     DE
        POP     HL
        LD      A,D
        XOR     H
        JP      M,LES1
        CALL    SSUB
LES1:   INC     H
        DEC     H
        JP      M,LES2
        LD      HL,0
        JP      HPUSH
LES2:   LD      HL,1
        JP      HPUSH
        ;
        .DB     $82    ;u<  UNSIGNED <
        .DB     "U",'<'+$80
        .DRW    LESS-4
ULESS:  .DRW    DOCOL,TDUP
        .DRW    XORR,ZLESS
        .DRW    ZBRAN,ULES1-*-2 ;IF
        .DRW    DROP,ZLESS
        .DRW    ZEQU
        .DRW    BRAN,ULES2-*-2
ULES1:  .DRW    SUBB,ZLESS      ;ELSE
ULES2:  .DRW    SEMIS   ; ENDIF
        ;
        .DB     $81    ; > GREATER THAN
        .DB     '>'+$80
        .DRW    ULESS-5
GREAT:  .DRW    DOCOL
        .DRW    SWAP
        .DRW    LESS
        .DRW    SEMIS
        ;
        .DB     $83    ; ROT
        .DB     "RO",'T'+$80
        .DRW    GREAT-4
ROT:    .DRW    *+2
        POP     DE
        POP     HL
        EX      (SP),HL
        JP      DPUSH
        ;
        .DB     $85    ;SPACE
        .DB     "SPAC",'E'+$80
        .DRW    ROT-6
SPACE:  .DRW    DOCOL
        .DRW    BL
        .DRW    EMIT
        .DRW    SEMIS
        ;
        .DB     $84    ;-DUP
        .DB     "-DU",'P'+$80
        .DRW    SPACE-8
DDUP:   .DRW    DOCOL
        .DRW    DUP
        .DRW    ZBRAN   ;IF
        .DRW    DDUP1-*
        .DRW    DUP     ;ENDIF
DDUP1:  .DRW    SEMIS
        ;
        .DB     $88    ; TRAVERSE
        .DB     "TRAVERS",'E'+$80
        .DRW    DDUP-7
TRAV:   .DRW    DOCOL
        .DRW    SWAP
TRAV1:  .DRW    OVER    ; BEGIN
        .DRW    PLUS
        .DRW    LIT
        .DRW    $7F
        .DRW    OVER
        .DRW    CAT
        .DRW    LESS
        .DRW    ZBRAN   ; UNTIL
        .DRW    TRAV1-*
        .DRW    SWAP
        .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $86    ; LATEST
        .DB     "LATES",'T'+$80
        .DRW    TRAV-$0B
LATES:  .DRW    DOCOL
        .DRW    CURR
        .DRW    AT
        .DRW    AT
        .DRW    SEMIS
        ;
        .DB     $83    ; LFA
        .DB     "LF",'A'+$80
        .DRW    LATES-9
LFA:    .DRW    DOCOL
        .DRW    LIT
        .DRW    4
        .DRW    SUBB
        .DRW    SEMIS
        ;
        .DB     $83    ; CFA
        .DB     "CF",'A'+$80
        .DRW    LFA-6
CFA:    .DRW    DOCOL
        .DRW    TWO
        .DRW    SUBB
        .DRW    SEMIS
        ;
        .DB     $83    ;NFA
        .DB     "NF",'A'+$80
        .DRW    CFA-6
NFA:    .DRW    DOCOL
        .DRW    LIT
        .DRW    5
        .DRW    SUBB
        .DRW    LIT
        .DRW    -1
        .DRW    TRAV
        .DRW    SEMIS
        ;
        .DB     $83    ;PFA
        .DB     "PF",'A'+$80
        .DRW    NFA-6
PFA:    .DRW    DOCOL
        .DRW    ONE
        .DRW    TRAV
        .DRW    LIT
        .DRW    5
        .DRW    PLUS
        .DRW    SEMIS
        ;
        .DB     $84    ;STORE CSP
        .DB     "!CS",'P'+$80
        .DRW    PFA-6
SCSP:   .DRW    DOCOL
        .DRW    SPAT
        .DRW    CSPP
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $86    ; ?ERROR
        .DB     "?ERRO",'R'+$80
        .DRW    SCSP-7
QERR:   .DRW    DOCOL
        .DRW    SWAP
        .DRW    ZBRAN   ;IF
        .DRW    QERR1-*
        .DRW    ERROR
        .DRW    BRAN    ; ELSE
        .DRW    QERR2-*
QERR1:  .DRW    DROP    ; ENDIF
QERR2:  .DRW    SEMIS
;
        .DB     $85    ; ?COMP
        .DB     "?COM",'P'+$80
        .DRW    QERR-9
QCOMP:  .DRW    DOCOL
        .DRW    STATE
        .DRW    AT
        .DRW    ZEQU
        .DRW    LIT
        .DRW    $11
        .DRW    QERR
        .DRW    SEMIS
        ;
        .DB     $85    ;?EXEC
        .DB     "?EXE",'C'+$80
        .DRW    QCOMP-8
QEXEC:  .DRW    DOCOL
        .DRW    STATE
        .DRW    AT
        .DRW    LIT
        .DRW    $12
        .DRW    QERR
        .DRW    SEMIS
        ;
        .DB     $86    ;?PAIRS
        .DB     "?PAIR",'S'+$80
        .DRW    QEXEC-8
QPAIR:  .DRW    DOCOL
        .DRW    SUBB
        .DRW    LIT
        .DRW    $13
        .DRW    QERR
        .DRW    SEMIS
        ;
        .DB     $84    ;?CSP
        .DB     "?CS",'P'+$80
        .DRW    QPAIR-9
QCSP:   .DRW    DOCOL
        .DRW    SPAT
        .DRW    CSPP
        .DRW    AT
        .DRW    SUBB
        .DRW    LIT
        .DRW    $14
        .DRW    QERR
        .DRW    SEMIS
        ;
        .DB     $88    ; ?LOADING
        .DB     "?LOADIN",'G'+$80
        .DRW    QCSP-7
QLOAD:  .DRW    DOCOL
        .DRW    BLK
        .DRW    AT
        .DRW    ZEQU
        .DRW    LIT
        .DRW    $16
        .DRW    QERR
        .DRW    SEMIS
        ;
        .DB     $87    ; COMPILE
        .DB     "COMPIL",'E'+$80
        .DRW    QLOAD-$0B
COMP:   .DRW    DOCOL
        .DRW    QCOMP
        .DRW    FROMR
        .DRW    DUP
        .DRW    TWOP
        .DRW    TOR
        .DRW    AT
        .DRW    COMMA
        .DRW    SEMIS
        ;
        .DB     $0C1   ; [ LEFT BRACKET
        .DB     '['+$80
        .DRW    COMP-$0A
LBRAC:  .DRW    DOCOL
        .DRW    ZERO
        .DRW    STATE
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $81    ; ] RIGHT BRACKET
        .DB     ']'+$80
        .DRW    LBRAC-4
RBRAC:  .DRW    DOCOL
        .DRW    LIT,$0C0
        .DRW    STATE,STORE
        .DRW    SEMIS
        ;
        .DB     $86    ;SMUDGE
        .DB     "SMUDG",'E'+$80
        .DRW    RBRAC-4
SMUDG:  .DRW    DOCOL
        .DRW    LATES
        .DRW    LIT
        .DRW    $20
        .DRW    TOGGL
        .DRW    SEMIS
        ;
        .DB     $83    ; HEX
        .DB     "HE",'X'+$80
        .DRW    SMUDG-9
HEX:    .DRW    DOCOL
        .DRW    LIT
        .DRW    $10
        .DRW    BASE
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $87    ;DECIMAL
        .DB     "DECIMA",'L'+$80
        .DRW    HEX-6
DECCX:  .DRW    DOCOL
        .DRW    LIT
        .DRW    $0A
        .DRW    BASE
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $87    ; (;CODE)
        .DB     "(;CODE",')'+$80
        .DRW    DECCX-$0A
PSCOD:  .DRW    DOCOL
        .DRW    FROMR
        .DRW    LATES
        .DRW    PFA
        .DRW    CFA
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $0C5   ; ;CODE
        .DB     ";COD",'E'+$80
        .DRW    PSCOD-$0A
SEMIC:  .DRW    DOCOL
        .DRW    QCSP
        .DRW    COMP
        .DRW    PSCOD
        .DRW    LBRAC
SEMI1:  .DRW    NOOP    ; (ASSEMBLER)
        .DRW    SEMIS
        ;
        .DB     $87    ; <BUILDS
        .DB     "<BUILD",'S'+$80
        .DRW    SEMIC-8
BUILD:  .DRW    DOCOL
        .DRW    ZERO
        .DRW    CON
        .DRW    SEMIS
        ;
        .DB     $85    ; DOES>
        .DB     "DOES",'>'+$80
        .DRW    BUILD-$0A
DOES:   .DRW    DOCOL
        .DRW    FROMR
        .DRW    LATES
        .DRW    PFA
        .DRW    STORE
        .DRW    PSCOD
DODOE:  LD      HL,(RPP)
        DEC     HL
        LD      (HL),B
        DEC     HL
        LD      (HL),C
        LD      (RPP),HL
        INC     DE
        EX      DE,HL
        LD      C,(HL)
        INC     HL
        LD      B,(HL)
        INC     HL
        JP      HPUSH
        ;
        .DB     $85    ; COUNT
        .DB     "COUN",'T'+$80
        .DRW    DOES-8
COUNT:  .DRW    DOCOL
        .DRW    DUP
        .DRW    ONEP
        .DRW    SWAP
        .DRW    CAT
        .DRW    SEMIS
        ;
        .DB     $84    ;  TYPE
        .DB     "TYP",'E'+$80
        .DRW    COUNT-8
TYPE:   .DRW    DOCOL
        .DRW    DDUP
        .DRW    ZBRAN   ;IF
        .DRW    TYPE1-*
        .DRW    OVER
        .DRW    PLUS
        .DRW    SWAP
        .DRW    XDO     ; DO
TYPE2:  .DRW    IDO
        .DRW    CAT
        .DRW    EMIT
        .DRW    XLOOP   ; LOOP
        .DRW    TYPE2-*
        .DRW    BRAN    ; ELSE
        .DRW    TYPE3-*
TYPE1:  .DRW    DROP    ; ENDIF
TYPE3:  .DRW    SEMIS
        ;
        .DB     $89    ; -TRAILING
        .DB     "-TRAILIN",'G'+$80
        .DRW    TYPE-7
DTRAI:  .DRW    DOCOL
        .DRW    DUP
        .DRW    ZERO
        .DRW    XDO     ; DO
DTRA1:  .DRW    OVER
        .DRW    OVER
        .DRW    PLUS
        .DRW    ONE
        .DRW    SUBB
        .DRW    CAT
        .DRW    BL
        .DRW    SUBB
        .DRW    ZBRAN   ; IF
        .DRW    DTRA2-*
        .DRW    LEAVE
        .DRW    BRAN    ; ELSE
        .DRW    DTRA3-*
DTRA2:  .DRW    ONE
        .DRW    SUBB    ; ENDIF
DTRA3:  .DRW    XLOOP   ; LOOP
        .DRW    DTRA1-*
        .DRW    SEMIS
        ;
        .DB     $84    ; (.")
        .DB     $28,$2E,$22,$0A9   ; (.")
        .DRW    DTRAI-$0C
PDOTQ:  .DRW    DOCOL
        .DRW    FRR
        .DRW    COUNT
        .DRW    DUP
        .DRW    ONEP
        .DRW    FROMR
        .DRW    PLUS
        .DRW    TOR
        .DRW    TYPE
        .DRW    SEMIS
        ;
        .DB     $0C2   ; ."
        .DB     $2E,$0A2
        .DRW    PDOTQ-7
DOTQ:   .DRW    DOCOL
        .DRW    LIT
        .DRW    $22
        .DRW    STATE
        .DRW    AT
        .DRW    ZBRAN   ;IF
        .DRW    DOTQ1-*
        .DRW    COMP
        .DRW    PDOTQ
        .DRW    WORD
        .DRW    HERE
        .DRW    CAT
        .DRW    ONEP
        .DRW    ALLOT
        .DRW    BRAN    ; ELSE
        .DRW    DOTQ2-*
DOTQ1:  .DRW    WORD
        .DRW    HERE
        .DRW    COUNT
        .DRW    TYPE    ;ENDIF
DOTQ2:  .DRW    SEMIS
        ;
        .DB     $86    ;EXPECT
        .DB     "EXPEC",'T'+$80
        .DRW    DOTQ-5
EXPEC:  .DRW    DOCOL
        .DRW    OVER
        .DRW    PLUS
        .DRW    OVER
        .DRW    XDO     ;DO
EXPE1:  .DRW    KEY
        .DRW    DUP
        .DRW    LIT
        .DRW    $0E
        .DRW    PORIG
        .DRW    AT
        .DRW    EQUAL
        .DRW    ZBRAN   ;IF
        .DRW    EXPE2-*
        .DRW    DROP
        .DRW    DUP
        .DRW    IDO
        .DRW    EQUAL
        .DRW    DUP
        .DRW    FROMR
        .DRW    TWO
        .DRW    SUBB
        .DRW    PLUS
        .DRW    TOR
        .DRW    ZBRAN   ;IF
        .DRW    EXPE6-*
        .DRW    LIT
        .DRW    BELL
        .DRW    BRAN    ; ELSE
        .DRW    EXPE7-*
EXPE6:  .DRW    LIT
        .DRW    BSOUT
;==================================
        .DRW    LIT
        .DRW    $20            ; ADDED TO DO PROPER BACKSPACE
        .DRW    LIT             ; (DESTRUCTIVE)
        .DRW    BSOUT           ; FINAL EMIT PROVIDED BY EXPE3:
        .DRW    EMIT
        .DRW    EMIT    ; ENDIF
;===================================
EXPE7:  .DRW    BRAN    ;ELSE
        .DRW    EXPE3-*
EXPE2:  .DRW    DUP
        .DRW    LIT
        .DRW    $0D
        .DRW    EQUAL
        .DRW    ZBRAN   ; IF
        .DRW    EXPE4-*
        .DRW    LEAVE
        .DRW    DROP
        .DRW    BL
        .DRW    ZERO
        .DRW    BRAN    ; ELSE
        .DRW    EXPE5-*
EXPE4:  .DRW    DUP     ; ENDIF
EXPE5:  .DRW    IDO
        .DRW    CSTOR
        .DRW    ZERO
        .DRW    IDO     
        .DRW    ONEP
        .DRW    STORE   ; ENDIF
EXPE3:  .DRW    EMIT
        .DRW    CURSOR
        .DRW    XLOOP   ; LOOP
        .DRW    EXPE1-*
        .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $85    ;QUERY
        .DB     "QUER",'Y'+$80
        .DRW    EXPEC-9
QUERY:  .DRW    DOCOL
        .DRW    TIB
        .DRW    AT
        .DRW    LIT
        .DRW    $50
        .DRW    EXPEC
        .DRW    ZERO
        .DRW    INN
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $0C1   ; 0 (NULL,BINARY ZERO, CNTL @)
        .DB     $80
        .DRW    QUERY-8
NULL:   .DRW    DOCOL
        .DRW    BLK
        .DRW    AT
        .DRW    ZBRAN   ; IF
        .DRW    NULL1-*
        .DRW    ONE
        .DRW    BLK
        .DRW    PSTOR
        .DRW    ZERO
        .DRW    INN
        .DRW    STORE
        .DRW    BLK
        .DRW    AT
        .DRW    BSCR
        .DRW    ONE
        .DRW    SUBB
        .DRW    ANDD
        .DRW    ZEQU
        .DRW    ZBRAN   ;IF
        .DRW    NULL2-*
        .DRW    QEXEC
        .DRW    FROMR
        .DRW    DROP    ; ENDIF
NULL2:  .DRW    BRAN    ;ELSE
        .DRW    NULL3-*
NULL1:  .DRW    FROMR
        .DRW    DROP    ;ENDIF
NULL3:  .DRW    SEMIS
        ;
        .DB     $84    ;FILL
        .DB     "FIL",'L'+$80
        .DRW    NULL-4
FILL:   .DRW    *+2
        LD      L,C
        LD      H,B
        POP     DE
        POP     BC
        EX      (SP),HL
        EX      DE,HL
FILL1:  LD      A,B     ;BEGIN
        OR      C
        JR      Z,FILL2 ;WHILE
        LD      A,L
        LD      (DE),A
        INC     DE
        DEC     BC
        JR      FILL1   ;REPEAT
FILL2:  POP     BC
        JP      NEXT
        ;
        .DB     $85    ;ERASE
        .DB     "ERAS",'E'+$80
        .DRW    FILL-7
ERASEE: .DRW    DOCOL
        .DRW    ZERO
        .DRW    FILL
        .DRW    SEMIS
        ;
        .DB     $86    ;BLANKS
        .DB     "BLANK",'S'+$80
        .DRW    ERASEE-8
BLANK:  .DRW    DOCOL
        .DRW    BL
        .DRW    FILL
        .DRW    SEMIS
        ;
        .DB     $84    ;HOLD
        .DB     "HOL",'D'+$80
        .DRW    BLANK-9
HOLD:   .DRW    DOCOL
        .DRW    LIT
        .DRW    -1
        .DRW    HLD
        .DRW    PSTOR
        .DRW    HLD
        .DRW    AT
        .DRW    CSTOR
        .DRW    SEMIS
        ;
        .DB     $83    ;PAD
        .DB     "PA",'D'+$80
        .DRW    HOLD-7
PAD:    .DRW    DOCOL
        .DRW    HERE
        .DRW    LIT
        .DRW    $44
        .DRW    PLUS
        .DRW    SEMIS
        ;
        .DB     $84    ; WORD  
        .DB     "WOR",'D'+$80
; : WORD BLK @ IF BLK @ BLOCK ELSE TIB @ ENDIF IN @ + SWAP ENCLOSE HERE 22 BLANK IN +! OVER -
;    >R R HERE C! + HERE 1+ R> CMOVE ;
        .DRW    PAD-6
WORD:   .DRW    DOCOL
        .DRW    BLK
        .DRW    AT
        .DRW    ZBRAN   ;IF
        .DRW    WORD1 -*
        .DRW    BLK
        .DRW    AT
        .DRW    BLOCK
        .DRW    BRAN    ; ELSE
        .DRW    WORD2-*
WORD1:  .DRW    TIB
        .DRW    AT      ;ENDIF
WORD2:  .DRW    INN
        .DRW    AT
        .DRW    PLUS
        .DRW    SWAP
        .DRW    ENCL
        .DRW    HERE
        .DRW    LIT
        .DRW    $22
        .DRW    BLANK
        .DRW    INN
        .DRW    PSTOR
        .DRW    OVER
        .DRW    SUBB
        .DRW    TOR
        .DRW    FRR
        .DRW    HERE
        .DRW    CSTOR
        .DRW    PLUS
        .DRW    HERE
        .DRW    ONEP
        .DRW    FROMR
        .DRW    CMOVE
        .DRW    SEMIS
        ;
        .DB     $88    ; (NUMBER)
        .DB     "(NUMBER",')'+$80
        .DRW    WORD-7
PNUMB:  .DRW    DOCOL
PNUM1:  .DRW    ONEP    ;BEGIN
        .DRW    DUP
        .DRW    TOR
        .DRW    CAT
        .DRW    BASE
        .DRW    AT
        .DRW    DIGIT
        .DRW    ZBRAN   ;WHILE
        .DRW    PNUM2-*
        .DRW    SWAP
        .DRW    BASE
        .DRW    AT
        .DRW    USTAR
        .DRW    DROP
        .DRW    ROT
        .DRW    BASE
        .DRW    AT
        .DRW    USTAR
        .DRW    DPLUS
        .DRW    DPL
        .DRW    AT
        .DRW    ONEP
        .DRW    ZBRAN   ; IF
        .DRW    PNUM3-*
        .DRW    ONE
        .DRW    DPL
        .DRW    PSTOR   ; ENDIF
PNUM3:  .DRW    FROMR
        .DRW    BRAN    ; REPEAT
        .DRW    PNUM1-*
PNUM2:  .DRW    FROMR
        .DRW    SEMIS
        ;
        .DB     $86    ;NUMBER
        .DB     "NUMBE",'R'+$80
        .DRW    PNUMB-$0B
NUMB:   .DRW    DOCOL
        .DRW    ZERO
        .DRW    ZERO
        .DRW    ROT
        .DRW    DUP
        .DRW    ONEP
        .DRW    CAT
        .DRW    LIT
        .DRW    $2D
        .DRW    EQUAL
        .DRW    DUP     
        .DRW    TOR
        .DRW    PLUS
        .DRW    LIT
        .DRW    -1
NUMB1:  .DRW    DPL     ; BEGIN
        .DRW    STORE
        .DRW    PNUMB
        .DRW    DUP
        .DRW    CAT
        .DRW    BL
        .DRW    SUBB
        .DRW    ZBRAN   ; WHILE
        .DRW    NUMB2-*
        .DRW    DUP
        .DRW    CAT
        .DRW    LIT
        .DRW    $2E
        .DRW    SUBB
        .DRW    ZERO
        .DRW    QERR
        .DRW    ZERO
        .DRW    BRAN    ; REPEAT
        .DRW    NUMB1-*
NUMB2:  .DRW    DROP
        .DRW    FROMR
        .DRW    ZBRAN   ;IF
        .DRW    NUMB3-*
        .DRW    DMINU   ;ENDIF
NUMB3:  .DRW    SEMIS
                ;
        .DB     $85    ; -FIND (0-3) SUCCESS
        .DB     "-FIN",'D'+$80 ;       (0-1) FAILURE
        .DRW    NUMB-9
DFIND:  .DRW    DOCOL
        .DRW    BL
        .DRW    WORD    
        .DRW    HERE
        .DRW    CONT
        .DRW    AT
        .DRW    AT
        .DRW    PFIND
        .DRW    DUP
        .DRW    ZEQU
        .DRW    ZBRAN   ;IF
        .DRW    DFIN1-*
        .DRW    DROP
        .DRW    HERE
        .DRW    LATES
        .DRW    PFIND   ;ENDIF
DFIN1:  .DRW    SEMIS
        ;
        .DB     $87    ; (ABORT)
        .DB     "(ABORT",')'+$80
        .DRW    DFIND-8
PABOR:  .DRW    DOCOL
        .DRW    ABORT
        .DRW    SEMIS
        ;
        .DB     $85    ; ERROR
        .DB     "ERRO",'R'+$80
        .DRW    PABOR-$0A
ERROR:  .DRW    DOCOL
        .DRW    WARN
        .DRW    AT
        .DRW    ZLESS
        .DRW    ZBRAN   ;IF
        .DRW    ERRO1-*
        .DRW    PABOR   ;ENDIF
ERRO1:  .DRW    HERE
        .DRW    COUNT
        .DRW    TYPE
        .DRW    PDOTQ
        .DB     2
        .DB     "? "
        .DRW    MESS
        .DRW    SPSTO
        ;       CHANGE FROM FIG MODEL
        ;       .DRW    INN,AT,BLK,AT
        .DRW    BLK,AT
        .DRW    DDUP
        .DRW    ZBRAN,ERRO2-*-2 ;IF
        .DRW    INN,AT
        .DRW    SWAP    ; ENDIF
ERRO2:  .DRW    QUIT
        ;
        .DB     $83    ; ID.
        .DB     "ID",'.'+$80
        .DRW    ERROR-8
IDDOT:  .DRW    DOCOL
        .DRW    PAD
        .DRW    LIT
        .DRW    $20
        .DRW    LIT
        .DRW    $5F
        .DRW    FILL
        .DRW    DUP
        .DRW    PFA
        .DRW    LFA
        .DRW    OVER
        .DRW    SUBB
        .DRW    PAD
        .DRW    SWAP
        .DRW    CMOVE
        .DRW    PAD
        .DRW    COUNT
        .DRW    LIT
        .DRW    $1F
        .DRW    ANDD
;=================================
        .DRW    DUP
        .DRW    PAD
        .DRW    PLUS
        .DRW    DUP
        .DRW    CAT
        .DRW    LIT
        .DRW    $7F
        .DRW    ANDD
        .DRW    SWAP
        .DRW    CSTOR
;=================================
        .DRW    TYPE
        .DRW    SPACE
        .DRW    SEMIS
        ;
        .DB     $86    ; CREATE
        .DB     "CREAT",'E'+$80
        .DRW    IDDOT-6
CREAT:  .DRW    DOCOL
        .DRW    DFIND
        .DRW    ZBRAN   ;IF
        .DRW    CREA1-*
        .DRW    DROP
        .DRW    NFA
        .DRW    IDDOT
        .DRW    LIT
        .DRW    4
        .DRW    MESS
        .DRW    SPACE   ;ENDIF
CREA1:  .DRW    HERE
        .DRW    DUP
        .DRW    CAT
        .DRW    WIDTH
        .DRW    AT
        .DRW    MIN
        .DRW    ONEP
        .DRW    ALLOT
        .DRW    DUP
        .DRW    LIT
        .DRW    $0A0
        .DRW    TOGGL
        .DRW    HERE
        .DRW    ONE
        .DRW    SUBB
        .DRW    LIT
        .DRW    $80
        .DRW    TOGGL
        .DRW    LATES
        .DRW    COMMA
        .DRW    CURR
        .DRW    AT
        .DRW    STORE
        .DRW    HERE
        .DRW    TWOP
        .DRW    COMMA
        .DRW    SEMIS
        ;
        .DB     $0C9   ; [COMPILE]
        .DB     "[COMPILE",']'+$80
        .DRW    CREAT-9
BCOMP:  .DRW    DOCOL
        .DRW    DFIND   
        .DRW    ZEQU
        .DRW    ZERO
        .DRW    QERR
        .DRW    DROP
        .DRW    CFA
        .DRW    COMMA
        .DRW    SEMIS
        ;
        .DB     $0C7   ; LITERAL
        .DB     "LITERA",'L'+$80
        .DRW    BCOMP-$0C
LITER:  .DRW    DOCOL
        .DRW    STATE
        .DRW    AT
        .DRW    ZBRAN   ;IF
        .DRW    LITE1-*
        .DRW    COMP
        .DRW    LIT
        .DRW    COMMA   ; ENDIF
LITE1:  .DRW    SEMIS
        ;
        .DB     $0C8   ; DLITERAL
        .DB     "DLITERA",'L'+$80
        .DRW    LITER-$0A
DLITE:  .DRW    DOCOL
        .DRW    STATE
        .DRW    AT
        .DRW    ZBRAN   ; IF
        .DRW    DLIT1-*
        .DRW    SWAP
        .DRW    LITER
        .DRW    LITER   ; ENDIF
DLIT1:  .DRW    SEMIS
        ;
        .DB     $86    ; ?STACK
        .DB     "?STAC",'K'+$80
        .DRW    DLITE-$0B
QSTAC:  .DRW    DOCOL
        .DRW    SPAT
        .DRW    SZERO
        .DRW    AT
        .DRW    SWAP
        .DRW    ULESS
        .DRW    ONE
        .DRW    QERR
        .DRW    SPAT
        .DRW    HERE
        .DRW    LIT
        .DRW    $80
        .DRW    PLUS
        .DRW    ULESS
        .DRW    LIT
        .DRW    7
        .DRW    QERR
        .DRW    SEMIS
        ;
        .DB     $89    ;INTERPRET
        .DB     "INTERPRE",'T'+$80
        .DRW    QSTAC-9
INTER:  .DRW    DOCOL
INTE1:  .DRW    DFIND   ; BEGIN
        .DRW    ZBRAN   ;IF
        .DRW    INTE2-*
        .DRW    STATE
        .DRW    AT
        .DRW    LESS
        .DRW    ZBRAN   ;IF
        .DRW    INTE3-*
        .DRW    CFA
        .DRW    COMMA
        .DRW    BRAN    ;ELSE
        .DRW    INTE4-*
INTE3:  .DRW    CFA
        .DRW    EXEC    ;ENDIF
INTE4:  .DRW    QSTAC
        .DRW    BRAN    ;ELSE
        .DRW    INTE5-*
INTE2:  .DRW    HERE
        .DRW    NUMB
        .DRW    DPL
        .DRW    AT
        .DRW    ONEP
        .DRW    ZBRAN   ;IF
        .DRW    INTE6-*
        .DRW    DLITE
        .DRW    BRAN    ;ELSE
        .DRW    INTE7-*
INTE6:  .DRW    DROP
        .DRW    LITER   ;ENDIF
INTE7:  .DRW    QSTAC   ;ENDIF
INTE5:  .DRW    BRAN    ;AGAIN
        .DRW    INTE1-*
        ;
        .DB     $89    ; IMMEDIATE
        .DB     "IMMEDIAT",'E'+$80
        .DRW    INTER-$0C
IMMED:  .DRW    DOCOL
        .DRW    LATES
        .DRW    LIT
        .DRW    $40
        .DRW    TOGGL
        .DRW    SEMIS
        ;
        .DB     $8A    ; VOCABULARY
        .DB     "VOCABULAR",'Y'+$80
        .DRW    IMMED-$0C
VOCAB:  .DRW    DOCOL
        .DRW    BUILD
        .DRW    LIT
        .DRW    $0A081
        .DRW    COMMA
        .DRW    CURR
        .DRW    AT
        .DRW    CFA
        .DRW    COMMA
        .DRW    HERE
        .DRW    VOCL
        .DRW    AT
        .DRW    COMMA
        .DRW    VOCL
        .DRW    STORE
        .DRW    DOES
DOVOC:  .DRW    TWOP
        .DRW    CONT
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $0C5   ;FORTH
        .DB     "FORT",'H'+$80
        .DRW    VOCAB-$0D
FORTH:  .DRW    DODOE
        .DRW    DOVOC
        .DRW    $0A081
        .DRW    fin_vocab  ; COLD START VALUE ONLY CHANGED $EAC TIME
        ;                 A DEF IS APPENDED TO THE FORTH VOCABULARY
        .DRW    0       ; END OF VOCABULARY LIST
        ;
        .DB     $8B    ; DEFINITIONS
        .DB     "DEFINITION",'S'+$80
        .DRW    FORTH-8
DEFIN:  .DRW    DOCOL
        .DRW    CONT
        .DRW    AT
        .DRW    CURR
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $0C1   ; (
        .DB     '('+$80
        .DRW    DEFIN-$0E
PAREN:  .DRW    DOCOL
        .DRW    LIT
        .DRW    $29
        .DRW    WORD
        .DRW    SEMIS
        ;
        .DB     $84    ; QUIT
        .DB     "QUI",'T'+$80
        .DRW    PAREN-4
QUIT:   .DRW    DOCOL
        .DRW    ZERO
        .DRW    BLK
        .DRW    STORE
        .DRW    LBRAC
QUIT1:  .DRW    RPSTO   ; BEGIN
        .DRW    CR
        .DRW    QUERY
        .DRW    INTER
        .DRW    STATE
        .DRW    AT
        .DRW    ZEQU
        .DRW    ZBRAN   ; IF
        .DRW    QUIT2-*
        .DRW    PDOTQ
        .DB     2
        .DB     "ok"    ; ENDIF
QUIT2:  .DRW    BRAN    ;AGAIN
        .DRW    QUIT1-*
        ;
        .DB     $85    ; ABORT
        .DB     "ABOR",'T'+$80
        .DRW    QUIT-7
ABORT:  .DRW    DOCOL
        .DRW    SPSTO
        .DRW    DECCX     
        .DRW    QSTAC
        .DRW    CR
 ;       .DRW    DOTCPU
        .DRW    PDOTQ
        .DB     $10
        .DB     "FIG-FORTH VG5000"
;        .DB     FIGREL+$30,ADOT,FIGREV+$30,USRVER
        .DRW    CR
        .DRW    PDOTQ
        .DB     $23
        .DB     "Implementation by Dominique Contant"
        .DRW    FORTH
        .DRW    DEFIN
        .DRW    QUIT
        ;
WRM:    LD      BC,WRM1
        JP      NEXT
WRM1:   .DRW    WARM
        ;
        .DB     $84    ;WARM
        .DB     "WAR",'M'+$80
        .DRW    ABORT-8
WARM:   .DRW    DOCOL
        .DRW    ABORT

CLD:    

	PUSH 	HL				; Indispensable pour retour Basic
	LD	(ret_basic),SP
	DI
	ld 	HL,script_40col_init
	call	lire_script
	CALL	efface_ecran
        LD      BC,CLD1
        LD      HL,(ORIG+$12)
        LD      SP,HL
        JP      NEXT
CLD1:   .DRW    COLD
        ;
        .DB     $84    ; COLD
        .DB     "COL",'D'+$80
        .DRW    WARM-7
COLD:   .DRW    DOCOL
        ;
        .DRW    LIT
        .DRW    ORIG+$12
        .DRW    LIT
        .DRW    UP
        .DRW    AT
        .DRW    LIT
        .DRW    6
        .DRW    PLUS
        .DRW    LIT
        .DRW    $10
        .DRW    CMOVE
        .DRW    LIT
        .DRW    ORIG+$0C
        .DRW    AT
        .DRW    LIT
        .DRW    FORTH+6
        .DRW    STORE   
        .DRW    ABORT
        ;
        .DB     $84    ; S-> D
        .DB     "S->",'D'+$80
        .DRW    COLD-7
STOD:   .DRW    *+2
        POP     DE
        LD      HL,0
        LD      A,D
        AND     $80
        JR      Z,STOD1
        DEC     HL
STOD1:  JP      DPUSH
        ;
        .DB     $82    ; +-
        .DB     "+",'-'+$80
        .DRW    STOD-7
PM:     .DRW    DOCOL
        .DRW    ZLESS
        .DRW    ZBRAN   ;IF
        .DRW    PM1-*
        .DRW    MINUS   ; ENDIF
PM1:    .DRW    SEMIS
        ;
        .DB     $83    ; D+-
        .DB     "D+",'-'+$80
        .DRW    PM-5
DPM:    .DRW    DOCOL
        .DRW    ZLESS
        .DRW    ZBRAN   ;IF
        .DRW    DPM1-*
        .DRW    DMINU   ; ENDIF
DPM1:   .DRW    SEMIS
        ;
        .DB     $83    ; ABS
        .DB     "AB",'S'+$80
        .DRW    DPM-6
ABS:    .DRW    DOCOL
        .DRW    DUP
        .DRW    PM
        .DRW    SEMIS
        ;
        .DB     $84    ; DABS
        .DB     "DAB",'S'+$80
        .DRW    ABS-6
DABS:   .DRW    DOCOL
        .DRW    DUP
        .DRW    DPM
        .DRW    SEMIS
        ;
        .DB     $83    ;MIN
        .DB     "MI",'N'+$80
        .DRW    DABS-7
MIN:    .DRW    DOCOL,TDUP
        .DRW    GREAT
        .DRW    ZBRAN   ;IF
        .DRW    MIN1-*
        .DRW    SWAP    ;ENDIF
MIN1:   .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $83    ;MAX
        .DB     "MA",'X'+$80
        .DRW    MIN-6
MAX:    .DRW    DOCOL,TDUP
        .DRW    LESS
        .DRW    ZBRAN   ; IF
        .DRW    MAX1-*
        .DRW    SWAP    ;ENDIF
MAX1:   .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $82    ; M*
        .DB     "M",'*'+$80
        .DRW    MAX-6
MSTAR:  .DRW    DOCOL,TDUP
        .DRW    XORR
        .DRW    TOR
        .DRW    ABS
        .DRW    SWAP
        .DRW    ABS
        .DRW    USTAR
        .DRW    FROMR
        .DRW    DPM
        .DRW    SEMIS
        ;
        .DB     $82    ; M/
        .DB     "M",'/'+$80
        .DRW    MSTAR-5
MSLAS:  .DRW    DOCOL
        .DRW    OVER
        .DRW    TOR
        .DRW    TOR
        .DRW    DABS
        .DRW    FRR
        .DRW    ABS
        .DRW    USLAS
        .DRW    FROMR
        .DRW    FRR
        .DRW    XORR
        .DRW    PM
        .DRW    SWAP
        .DRW    FROMR
        .DRW    PM
        .DRW    SWAP
        .DRW    SEMIS
        ;
        .DB     $81    ; *
        .DB     '*'+$80
        .DRW    MSLAS-5
STAR:   .DRW    DOCOL
        .DRW    MSTAR
        .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $84    ; /MOD
        .DB     "/MO",'D'+$80
        .DRW    STAR-4
SLMOD:  .DRW    DOCOL
        .DRW    TOR
        .DRW    STOD
        .DRW    FROMR
        .DRW    MSLAS
        .DRW    SEMIS
        ;
        .DB     $81    ;/
        .DB     '/'+$80
        .DRW    SLMOD-7
SLASH:  .DRW    DOCOL
        .DRW    SLMOD
        .DRW    SWAP
        .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $83    ;MOD
        .DB     "MO",'D'+$80
        .DRW    SLASH-4
MODD:   .DRW    DOCOL
        .DRW    SLMOD
        .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $85    ; */MOD
        .DB     "*/MO",'D'+$80
        .DRW    MODD-6
SSMOD:  .DRW    DOCOL
        .DRW    TOR
        .DRW    MSTAR
        .DRW    FROMR
        .DRW    MSLAS
        .DRW    SEMIS
        ;
        .DB     $82    ; */
        .DB     "*",'/'+$80
        .DRW    SSMOD-8
SSLA:   .DRW    DOCOL
        .DRW    SSMOD
        .DRW    SWAP
        .DRW    DROP
        .DRW    SEMIS
        ;
        .DB     $85    ; M/MOD
        .DB     "M/MO",'D'+$80
        .DRW    SSLA-5
MSMOD:  .DRW    DOCOL
        .DRW    TOR
        .DRW    ZERO
        .DRW    FRR
        .DRW    USLAS
        .DRW    FROMR
        .DRW    SWAP
        .DRW    TOR
        .DRW    USLAS
        .DRW    FROMR
        .DRW    SEMIS
        ;
        ;   BLOCK MOVED DOWN 2 PAGES
        ;
;
        .DB     $87    ; MESSAGE
        .DB     "MESSAG",'E'+$80
        .DRW    MSMOD-8
MESS:   .DRW    DOCOL
        .DRW    WARN
        .DRW    AT
        .DRW    ZBRAN   ;IF
        .DRW    MESS1-*
        .DRW    TWO
        .DRW    STAR
        .DRW    LIT
        .DRW    l45ba
        .DRW    PLUS
        .DRW    AT
	.DRW    COUNT
	.DRW    TYPE
	.DRW    SEMIS
MESS1:  .DRW    PDOTQ
        .DB     6
        .DB     "MSG # "
        .DRW    DOT     ; ENDIF
MESS3:  .DRW    SEMIS
;
        .DB     $085                   ; BLOCK
        .DB     "BLOC",'K'+$80
        .DRW    MESS-$0A
BLOCK:  .DRW    DOCOL
	.DRW 	ONE
	.DRW 	SUBB 
	.DRW 	LIT 
	.DRW 	$03ec 
	.DRW 	STAR 
	.DRW 	LIT 
	.DRW 	$7000 
	.DRW 	PLUS
	.DRW 	SEMIS 

;
;
;========================================================
;
;       CONSOLE I/O ROUTINES FOR VG 5000



;EPRINT: .DRW    $0000

CURSOR: .DRW    *+2
	CALL LMCURSOR
	JP	NEXT

LMCURSOR:
	LD	a,(CURSEUR)
	CALL	emit_c
	LD	HL, (emit_addr)
	DEC	HL
	LD	(emit_addr), HL
	RET
CURSEUR:	db $5F
	
PQTER:  CALL    32b7h
	LD      HL,0
        OR      A
        JP      Z,PQTER1
	JP      C,PQTER1        ; Si rptition
        INC     L               ;THEN (S1) <- TRUE
PQTER1: JP     HPUSH            ; ELSE (S1) <- FALSE


PKEY:   CALL    rd_kbd	; 
        LD      H,$00	; 
        LD      L,A
	JP      HPUSH   ; (S1) LB <- CHR

	; -----------------------------
	;  Routine de lecture du clavier
	;  Retour -> touche dans accumulateur A
	; -----------------------------
	; 
	; 
rd_kbd:	; 
        PUSH    HL				; 
        PUSH    BC				; 
        PUSH    DE				; 
	XOR	A				; Remise  zro accumulateur
waitakey:					; 
        CALL    32b7h                   	;  Lecture clavier
	JR 	C, waitakey			;  Si C alors rptition
	OR 	A
	JR	Z, waitakey			; Si aucune touche
        POP     DE				; 
        POP     BC				; 
        POP     HL				; 
        RET					; 


        ;
PEMIT:  .DRW    *+2             ;(EMIT) ORPHAN
        POP     HL
        LD      A, L
	CALL    emit_c
        JP      NEXT

        ;
PCR:    LD      A,ACR
        CALL    emit_c
	CALL LMCURSOR
        JP      NEXT


	; -------------
	;  Routine CLS - Efface Ecran
	; -------------
	; 
efface_ecran:
	PUSH	BC		; Sauvegarde registres
	PUSH	HL		; Sauvegarde registres
	LD	C,$CF
	ld	a,(copie_R2)
	ld	b,a
	ld	a,$22
	out	(8fh),A
	out	(C),B		; copie R2 dans R2
	ld	a,(copie_R3)
	ld	b,a
	ld	a,$23
	out	(8fh),A
	out	(C),B		; copie R3 dans R3
	ld	B,$01		; KRF (01) avec incrment pointer
	LD	A,$20		; R0
	out	(8fh),A
	out	(C),B		; 01 dans R0
	ld	a,ABL		; Espace
	ld	b,a
	LD	A,$21		; R1
	out	(8fh),A
	out	(C),B		; Espace dans R1
	XOR	A
	LD	H,A		; Ligne 0
	CALL	efface_ligne
	LD	H,$08		; seconde ligne=8
	LD	B,$18		; 18h LIGNES
loop_eff_ecran:
	PUSH	BC
	CALL	efface_ligne
	INC	H		; prochaine Ligne
	POP	BC
	DJNZ	loop_eff_ecran
	LD	HL, $0801
	LD 	(emit_addr), HL
	POP	HL
	POP	BC
	RET

	; -------------
	;  Routine EMIT 40 colonnes
	;  Imprime caractre A sur l'cran
	; -------------
	; 
emit_c:
	PUSH	BC		; Sauvegarde registres
	PUSH	HL		; Sauvegarde registres
	PUSH	DE
	LD	HL, (emit_addr)
	CP      0dh                     ;  Newline ?
        JR      Z,new_line           	;  fait new_line
        CP      03h                     ;  Newline ?
        JR      Z,new_line           	;  fait new_line
        CP      02h                     ;  Touche suppr ?
        JR      NZ,impression_emit      ;  Imprime caractre
back_space:
	LD	a, ABL			; espace
	ld	d,a
	CALL	print_scr		; imprime
	DEC	L			; Colonne= colonne-1
	LD	A,L
	OR	A
	JR 	NZ, maj_adr_imp 	; si non 0 mise a jour adresse
	DEC	H			; Ligne=ligne-1
	LD	A,H
	CP 	07h
	JR	Z, haut_max_ecran	; si hauteur maxi cran
	LD	L,27h			; Colonne fin de ligne
	JR	maj_adr_imp 
haut_max_ecran:
	LD	HL,0801h		; Maxi cran=Ligne8 colonne 1
	JR	maj_adr_imp 
new_line:
	LD	A,H  
	CP	1Fh			; Fin cran ?
	JR	Z, faire_scroll
	INC	H			; ligne=ligne+1
retour_scroll:
	LD	L,01h			; colonne=1
	JR 	maj_adr_imp 
faire_scroll:
	CALL 	scr_up
	JR 	retour_scroll 
impression_emit:			; Imprime caractere
	LD	D,A			; Dans D
	CALL	print_scr
	INC	L			; Colonne = colonne+1
	LD	A,L
	CP 	28h			; Fin de de la ligne ?
	JR	Z,new_line
maj_adr_imp:
	LD	(emit_addr),HL		; Mise a jour adresse
	POP	DE			; rcupre registres
	POP	HL			; rcupre registres
	POP	BC			; rcupre registres
	RET
	; 
	; -------------
	;  Routine Scroll cran
	; -------------
	; 
scr_up:	; 
	PUSH	BC		; Sauvegarde registres
	PUSH	HL		; Sauvegarde registres
	LD	H,08h		; Ligne H=8h
	LD	B,17h		; 17h lignes
loop_scr_ligne:
	PUSH	BC		; Sauvegarde compteur de loop
	CALL	scroll_ligne	
	INC	H		; Ligne H +1
	POP	BC		; Rcupre compteur de loop
	DJNZ	loop_scr_ligne	; 17 x
	LD	C,$CF
	ld	B,$01		; KRF (01) avec incrment pointer
	LD	A,$20		; R0
	out	(8fh),A
	out	(C),B		; 01 dans R0
	ld	a, ABL		; Espace
	ld	b,a
	LD	A,$21		; R1
	out	(8fh),A
	out	(C),B		; Espace dans R1
	call	$0286		; attente EF9345 prt
	LD	H,1Fh		; Dernire ligne
	CALL	efface_ligne
	LD	L,01h		; Colonne 1
	LD	(emit_addr),HL	; Mise a jour adresse
        POP     HL		; Rcupre registres
	POP     BC		; Rcupre registres
	RET
	; 
	; -------------
	;  Scroll d'une ligne L
	;  Ligne  copier dans H bis , Copie dans H
	; -------------
	; 

scroll_ligne:
	ld	c,$cf
	ld	e,00
	ld	a,$27
	out	($8f),a
	out	(c),e
	ld	a,$25
	out	($8f),a
	out	(c),e
	ld	a,$26
	out	($8f),a
	out	(c),h
	inc	h
	ld	a,$24
	out	($8f),a
	out	(c),h
	ld	e,$d9
	ld	a,$28
	out	($8f),a
	out	(c),e
	call	$0286
	dec	h
	ret
	; -------------
	;  Routine Imprime Ecran
	; -------------
	; 

print_scr:			; Imprime cran
	call	$0286		;attente EF9345 prt
	ld      c,$cf
	ld      a,26h           ;26=Main pointer R6 (Y)
	out     (8fh),a
	out     (c),h
	ld      a,27h           ;27=Main pointer R7 (X)
	out     (8fh),a
	out     (c),l
	ld      a,20h           ;20=Command register
	out     (8fh),a
	call	$0286		;attente EF9345 prt
	ld	a,(copie_R2)
	ld	b,a
	ld	a,$22
	out	(8fh),A
	out	(C),B		; copie R2 dans R2
	ld	a,(copie_R3)
	ld	b,a
	ld	a,$23
	out	(8fh),A
	out	(C),B		; copie R3 dans R3
	ld      a,20h           ;20=Command register 
	out     (8fh),a
	call	$0286		;attente EF9345 prt
	ld      a,21h           ;21=Data register R1
	out     (8fh),a
	out     (c),d           ;envoi du caractere 'd'
	ld	b,00
	ld      a,28h           ;28=Command register + exec request
	out     (8fh),a
	out     (c),b           ;00 = ecriture KRF mode 40 car. 24 bits 
	call	$0286		;attente EF9345 prt
	ret     
	; -------------
	;  Efface une ligne : Ligne H,  - Commande KRF (01) avec incrment pointer ligne dans R0, Espace dans R1
	;  Attribut dans R2 couleur dans R3
	; -------------
	; 
efface_ligne:
	XOR A			;CLR R7 - Colonne 0
	LD	B,A
	LD	A,$27
	out	(8fh),A
	out	(C),B		; 0 dans R7
	LD	B,$28		; Nombre colonnes
loop_eff_ligne:	
	LD	A,$2E		; R6+EXEC
	out	(8fh),A
	out	(C),H		; Ligne L dans R6
	call	$0286		;attente EF9345 prt
	DJNZ	loop_eff_ligne			; 27 x
	RET

;***************************( END OF I/O ) ********************
;**************************************************************;

        .DB     $0C1   ; ' (tick)
        .DB     $0A7   
        .DRW    BLOCK-8
TICK:   .DRW    DOCOL
        .DRW    DFIND
        .DRW    ZEQU
        .DRW    ZERO
        .DRW    QERR
        .DRW    DROP
        .DRW    LITER
        .DRW    SEMIS
        ;
        .DB     $86    ;FORGET
        .DB     "FORGE",'T'+$80        ; THIS IS NOT THE FORGIVING FORGET
        .DRW    TICK-4
FORG:   .DRW    DOCOL
        .DRW    CURR
        .DRW    AT
        .DRW    CONT
        .DRW    AT
        .DRW    SUBB
        .DRW    LIT
        .DRW    $18
        .DRW    QERR
        .DRW    TICK
        .DRW    DUP
        .DRW    FENCE
        .DRW    AT
        .DRW    LESS
        .DRW    LIT
        .DRW    $15
        .DRW    QERR
        .DRW    DUP
        .DRW    NFA
        .DRW    DP
        .DRW    STORE
        .DRW    LFA
        .DRW    AT
        .DRW    CONT    
        .DRW    AT
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $84    ; BACK
        .DB     "BAC",'K'+$80
        .DRW    FORG-9
BACK:   .DRW    DOCOL
        .DRW    HERE
        .DRW    SUBB
        .DRW    COMMA
        .DRW    SEMIS
        ;
        .DB     $0C5   ;BEGIN
        .DB     "BEGI",'N'+$80
        .DRW    BACK-7
BEGIN:  .DRW    DOCOL
        .DRW    QCOMP
        .DRW    HERE
        .DRW    ONE
        .DRW    SEMIS
        ;
        .DB     $0C5   ; ENDIF
        .DB     "ENDI",'F'+$80
        .DRW    BEGIN-8
ENDIFF: .DRW    DOCOL
        .DRW    QCOMP
        .DRW    TWO
        .DRW    QPAIR
        .DRW    HERE
        .DRW    OVER
        .DRW    SUBB
        .DRW    SWAP
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $0C4   ;THEN
        .DB     "THE",'N'+$80
        .DRW    ENDIFF-8
THEN:   .DRW    DOCOL
        .DRW    ENDIFF
        .DRW    SEMIS
        ;
        .DB     $0C2   ; DO
        .DB     "D",'O'+$80
        .DRW    THEN-7
DO:     .DRW    DOCOL
        .DRW    COMP
        .DRW    XDO
        .DRW    HERE
        .DRW    THREE
        .DRW    SEMIS
        ;
        .DB     $0C4   ;LOOP
        .DB     "LOO",'P'+$80
        .DRW    DO-5
LOOP:   .DRW    DOCOL
        .DRW    THREE
        .DRW    QPAIR
        .DRW    COMP
        .DRW    XLOOP
        .DRW    BACK
        .DRW    SEMIS
        ;
        .DB     $0C5   ; +LOOP
        .DB     "+LOO",'P'+$80
        .DRW    LOOP-7
PLOOP:  .DRW    DOCOL
        .DRW    THREE
        .DRW    QPAIR
        .DRW    COMP
        .DRW    XPLOO
        .DRW    BACK
        .DRW    SEMIS
        ;
        .DB     $0C5   ;UNTIL
        .DB     "UNTI",'L'+$80
        .DRW    PLOOP-8
UNTIL:  .DRW    DOCOL
        .DRW    ONE
        .DRW    QPAIR
        .DRW    COMP
        .DRW    ZBRAN
        .DRW    BACK
        .DRW    SEMIS
        ;
        .DB     $0C3   ;END
        .DB     "EN",'D'+$80
        .DRW    UNTIL-8
ENDD:   .DRW    DOCOL
        .DRW    UNTIL
        .DRW    SEMIS
        ;
        .DB     $0C5   ; AGAIN
        .DB     "AGAI",'N'+$80
        .DRW    ENDD-6
AGAIN:  .DRW    DOCOL
        .DRW    ONE
        .DRW    QPAIR
        .DRW    COMP
        .DRW    BRAN
        .DRW    BACK
        .DRW    SEMIS
        ;
        .DB     $0C6   ; REPEAT
        .DB     "REPEA",'T'+$80
        .DRW    AGAIN-8
REPEA:  .DRW    DOCOL
        .DRW    TOR
        .DRW    TOR
        .DRW    AGAIN
        .DRW    FROMR
        .DRW    FROMR
        .DRW    TWO
        .DRW    SUBB
        .DRW    ENDIFF
        .DRW    SEMIS
        ;
        .DB     $0C2   ; IF
        .DB     "I",'F'+$80
        .DRW    REPEA-9
IFF:    .DRW    DOCOL
        .DRW    COMP
        .DRW    ZBRAN
        .DRW    HERE
        .DRW    ZERO
        .DRW    COMMA
        .DRW    TWO
        .DRW    SEMIS
        ;
        .DB     $0C4   ;ELSE
        .DB     "ELS",'E'+$80
        .DRW    IFF-5
ELSEE:  .DRW    DOCOL
        .DRW    TWO
        .DRW    QPAIR
        .DRW    COMP
        .DRW    BRAN
        .DRW    HERE
        .DRW    ZERO
        .DRW    COMMA
        .DRW    SWAP
        .DRW    TWO
        .DRW    ENDIFF
        .DRW    TWO
        .DRW    SEMIS
        ;
        .DB     $0C5   ; WHILE
        .DB     "WHIL",'E'+$80
        .DRW    ELSEE-7
WHILE:  .DRW    DOCOL
        .DRW    IFF
        .DRW    TWOP
        .DRW    SEMIS
        ;
        .DB     $86    ;SPACES
        .DB     "SPACE",'S'+$80
        .DRW    WHILE-8
SPACS:  .DRW    DOCOL
        .DRW    ZERO
        .DRW    MAX
        .DRW    DDUP
        .DRW    ZBRAN   ;IF
        .DRW    SPAX1-*
        .DRW    ZERO
        .DRW    XDO     ;DO
SPAX2:  .DRW    SPACE
        .DRW    XLOOP   ;LOOP ENDIF
        .DRW    SPAX2-*
SPAX1:  .DRW    SEMIS
        ;
        .DB     $82    ; <#
        .DB     "<",'#'+$80
        .DRW    SPACS-9
BDIGS:  .DRW    DOCOL
        .DRW    PAD
        .DRW    HLD
        .DRW    STORE
        .DRW    SEMIS
        ;
        .DB     $82    ; #>
        .DB     "#",'>'+$80
        .DRW    BDIGS-5
EDIGS:  .DRW    DOCOL
        .DRW    DROP
        .DRW    DROP
        .DRW    HLD
        .DRW    AT
        .DRW    PAD
        .DRW    OVER
        .DRW    SUBB
        .DRW    SEMIS
        ;
        .DB     $84    ;SIGN
        .DB     "SIG",'N'+$80
        .DRW    EDIGS-5
SIGN:   .DRW    DOCOL
        .DRW    ROT
        .DRW    ZLESS
        .DRW    ZBRAN   ;IF
        .DRW    SIGN1-*
        .DRW    LIT
        .DRW    $2D    ;
        .DRW    HOLD    ;ENDIF
SIGN1:  .DRW    SEMIS
        ;
        .DB     $81    ; #
        .DB     '#'+$80
        .DRW    SIGN-7
DIG:    .DRW    DOCOL
        .DRW    BASE
        .DRW    AT
        .DRW    MSMOD
        .DRW    ROT
        .DRW    LIT
        .DRW    9
        .DRW    OVER
        .DRW    LESS
        .DRW    ZBRAN   ;IF
        .DRW    DIG1-*
        .DRW    LIT
        .DRW    7
        .DRW    PLUS    ;ENDIF
DIG1:   .DRW    LIT
        .DRW    $30
        .DRW    PLUS
        .DRW    HOLD
        .DRW    SEMIS
        ;
        .DB     $82    ; #S
        .DB     "#",'S'+$80
        .DRW    DIG-4
DIGS:   .DRW    DOCOL
DIGS1:  .DRW    DIG     ; BEGIN
        .DRW    OVER
        .DRW    OVER
        .DRW    ORR
        .DRW    ZEQU
        .DRW    ZBRAN   ; UNTIL
        .DRW    DIGS1-*
        .DRW    SEMIS
        ;
        .DB     $83    ; D.R
        .DB     "D.",'R'+$80
        .DRW    DIGS-5
DDOTR:  .DRW    DOCOL
        .DRW    TOR
        .DRW    SWAP    
        .DRW    OVER
        .DRW    DABS
        .DRW    BDIGS
        .DRW    DIGS
        .DRW    SIGN
        .DRW    EDIGS
        .DRW    FROMR
        .DRW    OVER    
        .DRW    SUBB
        .DRW    SPACS
        .DRW    TYPE
        .DRW    SEMIS
        ;
        .DB     $82    ; .R
        .DB     ".",'R'+$80
        .DRW    DDOTR-6
DOTR:   .DRW    DOCOL
        .DRW    TOR
        .DRW    STOD
        .DRW    FROMR
        .DRW    DDOTR
        .DRW    SEMIS
        ;
        .DB     $82    ;D.
        .DB     "D",'.'+$80
        .DRW    DOTR-5
DDOT:   .DRW    DOCOL
        .DRW    ZERO
        .DRW    DDOTR
        .DRW    SPACE
        .DRW    SEMIS
        ;
        .DB     $81    ; .
        .DB     '.'+$80
        .DRW    DDOT-5
DOT:    .DRW    DOCOL
        .DRW    STOD
        .DRW    DDOT
        .DRW    SEMIS
        ;
        .DB     $81    ; ?
        .DB     '?'+$80
        .DRW    DOT-4
QUES:   .DRW    DOCOL
        .DRW    AT
        .DRW    DOT
        .DRW    SEMIS
;
        .DB     $82                            ; U.
        .DB     "U",'.'+$80
        .DRW    QUES-4
UDOT:   .DRW    DOCOL
        .DRW    ZERO
        .DRW    DDOT
        .DRW    SEMIS
;
        .DB     $85                            ; VLIST
        .DB     "VLIS",'T'+$80
        .DRW    UDOT-5
VLIST:  .DRW    DOCOL
        .DRW    LIT
        .DRW    $80
        .DRW    OUTT
        .DRW    STORE
        .DRW    CONT
        .DRW    AT
        .DRW    AT
VLIS1:  .DRW    OUTT                            ;BEGIN
        .DRW    AT
        .DRW    CSLL
        .DRW    GREAT
        .DRW    ZBRAN                           ;IF
        .DRW    VLIS2-*
        .DRW    CR
        .DRW    ZERO
        .DRW    OUTT
        .DRW    STORE                           ;ENDIF
VLIS2:  .DRW    DUP
        .DRW    IDDOT
        .DRW    SPACE
        .DRW    SPACE   
        .DRW    PFA
        .DRW    LFA
        .DRW    AT
        .DRW    DUP
        .DRW    ZEQU
        .DRW    QTERM
        .DRW    ORR
        .DRW    ZBRAN                           ;UNTIL
        .DRW    VLIS1-*
        .DRW    DROP
        .DRW    SEMIS
;
;-----------
;       EXIT    
;
        .DB     $83
        .DB     "BY",'E'+$80
        .DRW    VLIST-8
BYE:    .DRW    *+2
	LD	C, $CF
	LD	B, $F7
	LD	A, $21
	OUT	($8F), A
	OUT	(C), B
	LD	B, $83
	LD	A, $28
	OUT	($8F), A
	OUT	(C), B
	CALL	$0286
	EI
	LD	SP,(ret_basic)
	POP	HL
	RET

;=========================
;       .S      (DOT S) DISP STACK (NON DESTRUCTIVE!)
;

        .DB     $84            ;PICK
        .DB     "PIC",'K'+$80
        .DRW    BYE-6
PICK:   .DRW    *+2
        EXX             ; SAVE REGS
        POP     DE      ; GET REG # OFF STACK
        LD      A,E
        RLA
        LD      E,A     ; SHIFT TO MUL BY 2
;
        LD      HL,2
        ADD     HL,SP   ; (SP) --> (HL)
;
        ADD     HL,DE   ; MAKES HL = ACTUAL STACK ADDRESS FOR DATA
        DEC     HL
        LD      B,(HL)
        DEC     HL
        LD      C,(HL)
        PUSH    BC
        EXX
        JP      NEXT

fin_vocab:       
        .DB     $83            ;CLS
        .DB     "CL",'S'+$80
        .DRW    PICK-7
CLS:   .DRW    *+2
       	CALL 	efface_ecran
	JP 	NEXT
INITDP: NOP
;
.end
